(function ($) {
    "use strict";
    wio_data = wio_data[0];
    var wio_customizers = new Array();
    var wio_customizerApp = false;
    var wio_currentCustomizer = false;
    var wio_currentStep = false;
    var wio_currentStepField = false;
    var wio_modifsDone = false;
    var wio_linkingFromStep = false;
    var wio_currentLink = false;
    var wio_viewportMousePosition;
    var wio_calculationEditor = false;
    var wio_currentCalcConditions = false;
    var wio_lightPosition = 0;
    var wio_imgField = false;
    var wio_currentImg = false;
    var wio_currentImgConditions = false;
    var wio_linkGradientIndex = 1;
    var wio_hightlightedLinks = new Array();
    var wio_hightlightedActiveLinks = new Array();

    $(document).ready(function () {
        initCodemirror();
        initEditors();
        initListeners();
        initCustomizerApp();
        loadCustomizers();
    });


    function initEditors() {
        $('#wio_editFieldText').richText();
        $('#wio_editFieldTooltip').richText();
    }
    function initCodemirror() {
        wio_calculationEditor = CodeMirror.fromTextArea($('#wio_editFieldCalculationBloc textarea[name="priceCalculation"]').get(0), {
            mode: "javascript",
            lineNumbers: true
        });
        setTimeout(function () {

            $('.CodeMirror-scroll').addClass('form-control');
            $('.CodeMirror').addClass('mt-2');
        }, 500);

    }

    function loadCustomizers() {
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_loadCustomizers'
            },
            success: function (data) {
                wio_customizers = JSON.parse(data);
                for (var i = 0; i < wio_customizers.length; i++) {
                    wio_customizers[i].jsonData = JSON.parse(wio_customizers[i].jsonData);
                    if (typeof (wio_customizers[i].jsonData.links) == 'undefined') {
                        wio_customizers[i].jsonData.links = [];
                    }
                }
                updateCustomizersList();
                $('#wio_loader').fadeOut();
            }
        });
    }
    function initListeners() {
        $('a[data-wioaction="createCustomizer"]').on('click', createCustomizer);
        $('[data-wioaction="confirmRemoveCustomizer"]').on('click', confirmRemoveCustomizer);
        $('#wio_editFieldType').on('change', onStepFieldTypeChanged);
        $('a[data-wioaction="saveStepField"]').on('click', saveStepField);
        $('[data-wioaction="saveAndLeave"]').on('click', saveAndLeave);
        $('[data-wioaction="saveCustomizer"]').on('click', saveCustomizer);
        $('[data-wioaction="savePreview"]').on('click', saveAndPreview);
        $('[data-wioaction="startPreview"]').on('click', startPreview);

        $('[data-wioaction="leave"]').on('click', leave);
        $('[data-wioaction="addStep"]').on('click', addStep);
        $('a[data-wioaction="addOptionConditionGroup"]').on('click', addOptionConditionGroup);
        $('[data-wioaction="saveSettings"]').on('click', saveSettings);
        $('#wio_winSelectValue [data-wioaction="insertValue"]').on('click', insertCalculationValue);
        $('#wio_winEditLink [data-wioaction="insertConditions"]').on('click', insertCalcConditions);
        $('#wio_winEditLink [data-wioaction="deleteLink"]').on('click', function () {
            deleteLink(wio_currentLink.id);
            $('#wio_winEditLink').modal('hide');
        });

        $('#adminmenu a, #wpadminbar a').on('click', function () {
            if ($(this).attr('href').indexOf('javascript:') == -1 && $(this).attr('href') != '#') {
                if (wio_modifsDone) {
                    askSaveBeforeLeave($(this).attr('href'));
                    return false;
                }
            }
        });
        $(window).on('keydown', function (e) {
            if (e.which == 116 && wio_modifsDone) {
                askSaveBeforeLeave(document.location.href);
                return false;
            }
        });
        $('[data-wioaction="openSettings"]').on('click', function () {
            updateSettings();
            $('#wio_winSettings a[data-wiotab="options"]').trigger('click');
            $('#wio_winSettings').modal('show');
        });
        $('ul a[data-wiotab]').on('click', function () {
            var tab = $(this).attr('data-wiotab');
            $(this).closest('ul').find('a[data-wiotab]').removeClass('active');
            $(this).closest('ul').find('a[data-wiotab="' + tab + '"]').addClass('active');
            $(this).closest('ul').parent().find('div[data-wiotab]').hide();
            $(this).closest('ul').parent().find('div[data-wiotab="' + tab + '"]').show();
        });
        $('#wio_winEditStepField [name="useCalculation"]').on('change', onEditFieldUseCalculationChange);
        $('#wio_winEditStepField [name="useTooltip"]').on('change', onEditFieldUseTooltipChange);
        
        $('#wio_selectValueItem').on('change', onSelectValueItemChanged);

        $('[data-wioaction="addCalculationValue"]').on('click', showWinCalculationAddValue);
        $('#wio_settings_pricesInResume').on('change', function () {
            if ($('#wio_settings_pricesInResume').is(':checked')) {
                $('#wio_settings_totalInResume').closest('.row').show();
            } else {
                $('#wio_settings_totalInResume').closest('.row').hide();
            }
        });
        $('#wio_settings_modifyPrice').on('change', onSettingsModifypriceChange);
        $('[data-wioaction="addCalculationCondition"]').on('click', showWinCalcConditions);

        window.old_tb_remove = window.tb_remove;
        window.tb_remove = function () {
            window.old_tb_remove();
            wio_imgField = null;
        };
        window.original_send_to_editor = window.send_to_editor;
        window.send_to_editor = function (html) {
            if (wio_imgField) {
                var alt = jQuery('img', html).attr('alt');
                var fileurl = jQuery('img', html).attr('src');
                if (jQuery('img', html).length == 0) {
                    fileurl = jQuery(html).attr('src');
                    alt = jQuery(html).attr('alt');
                }
                wio_imgField.val(fileurl);
                wio_imgField.trigger('keyup');
                tb_remove();
            } else {
                window.original_send_to_editor(html);
            }
        };
        $('[data-wioaction="editDynamicImg"]').on('click', showWinDynamicImg);
        $('#wio_dynamicImgsTable [data-wioaction="addImg"]').on('click', function () {
            var imgData = {
                id: generateID(),
                image: wio_data.placeholderImg,
                operator: 'and',
                conditions: new Array()
            };
            wio_currentCustomizer.jsonData.imgConditions.push(imgData);
            addDynamicImage(imgData);
        });

        $('#wio_winEditLink').on('hide.bs.modal', function () {
            $('#wio_linkConditionsList').html('');
            if (wio_currentImgConditions) {
                $('#wio_winDynamicImg').modal('show');
                wio_currentImg = false;
                wio_currentImgConditions = false;
            }
        });
        $('#wio_winEditStepField [name="type"]').on('change', onTextTypeChanged);
        $('a[data-wioaction="exportData"]').on('click', exportData);
        $('a[data-wioaction="importData"]').on('click', importData);
        $('a[data-wioaction="confirmImportData"]').on('click', confirmImportData);

        $('a[data-wioaction="showWinLicense"]').on('click', function () {
            $('#wio_winLicense').modal('show');
        });
        $('#wio_mainHeader a.btn-circle[title]').tooltip({
            container: '.wio_root',
            placement: 'left'
        });
        $('a[data-wioaction="validatePurchaseCode"]').on('click', validatePurchaseCode);

        $('.wio_btnImgField').on('click', function () {
            wio_imgField = $(this).closest('.input-group').find('input[type="text"]');
            tb_show('', 'media-upload.php?TB_iframe=true');
            return false;
        });
        $('#wio_settings_popup').on('change', function () {
            if ($('#wio_settings_popup').is(':checked')) {
                $('#wio_settings_centerContent').closest('.row').hide();
            } else {
                $('#wio_settings_centerContent').closest('.row').show();
            }
        });

        jQuery('#wio_previewSelectProduct').autocomplete({
            appendTo: jQuery('.wio_root'),
            change: function (event, ui) {
                jQuery(this).val((ui.item ? ui.item.value : ""));
            },
            source: function (request, response) {
                jQuery.ajax({
                    url: ajaxurl,
                    dataType: "json",
                    type: 'post',
                    data: {
                        action: 'wio_getWooProductsByTerm',
                        term: request.term
                    },
                    success: function (data) {
                        jQuery('#wio_previewSelectProduct').removeClass('ui-autocomplete-loading');
                        response(data);
                    }
                });
            },
            minLength: 2,
            select: function (event, ui) {
                var data = ui.item;
                var $sel = jQuery('#wio_winPreview').find('[name="wio_previewSelectProductID"]');
                $sel.attr('data-id', data.id);
                $sel.val(data.id).trigger('change');
            }
        });

        $('[data-wioaction="returnToList"]').on('click', function () {
            if (wio_modifsDone) {
                askSaveBeforeLeave(document.location.href);
            } else {
                document.location.reload();
            }
        });

    }
    function startPreview() {
        $('#wio_previewSelectProduct').removeClass('is-invalid');
        var wooID = $('#wio_winPreview [name="wio_previewSelectProductID"]').val();
        if (wooID != '' && wooID > 0 && $('#wio_previewSelectProduct').val() != '') {
            $('#wio_loader').fadeIn();
            $.ajax({
                url: ajaxurl,
                type: 'post',
                data: {
                    action: 'wio_previewCustomizer',
                    customizerID: wio_currentCustomizer.id,
                    wooProduct: wooID
                },
                success: function (url) {
                    $('#wio_winPreview').modal('hide');
                    $('#wio_loader').fadeOut();
                    var win = window.open(url, '_blank');
                    if (typeof (win) !== 'null' && win != null) {
                        win.focus();
                    }
                }
            });
        } else {
            $('#wio_previewSelectProduct').addClass('is-invalid');

        }
    }
    function validatePurchaseCode() {
        var purchaseCode = $('#wio_licensePurchaseField').val();
        $('#wio_licensePurchaseField').removeClass('is-invalid');
        if (purchaseCode.trim().length == 0) {
            $('#wio_licensePurchaseField').addClass('is-invalid');
        } else {
            $('#wio_loader').fadeIn();
            $.ajax({
                url: ajaxurl,
                type: 'post',
                data: {
                    action: 'wio_validatePurchaseCode',
                    code: purchaseCode
                },
                success: function (rep) {
                    if (rep != 1) {
                        $('#wio_winLicense').modal('hide');
                        $('#wio_loader').fadeOut();
                    } else {
                        $('#wio_loader').fadeOut();
                        $('#wio_licensePurchaseField').addClass('is-invalid');
                    }
                }
            });
        }
    }
    function confirmImportData() {
        $('#wio_loader').fadeIn();
        jQuery('#wio_winImportData').modal('hide');

        var formData = new FormData(jQuery('#wio_winImportForm')[0]);

        jQuery.ajax({
            url: ajaxurl,
            type: 'post',
            xhr: function () {
                var myXhr = jQuery.ajaxSettings.xhr();
                return myXhr;
            },
            success: function (rep) {
                if (rep != '1') {
                    $('#wio_loader').fadeOut();
                    alert(wio_data.texts['errorImport']);
                } else {
                    document.location.reload();
                }
            },
            data: formData,
            cache: false,
            contentType: false,
            processData: false
        });
    }
    function exportData() {
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_exportData'
            },
            success: function () {
                var win = window.open('admin.php?page=wio_menu&wio_action=exportData', '_blank');
                if (typeof (win) !== 'null' && win != null) {
                    win.focus();
                }
            }
        });
    }
    function importData() {
        $('#wio_winImportData').modal('show');
    }
    function deleteLink(id) {
        wio_modifsDone = true;
        var linkGraph = wio_customizerApp.stage.getChildByName("link_" + id);
        var editLink = wio_customizerApp.stage.getChildByName("editLink_" + id);
        var lightLink = wio_customizerApp.stage.getChildByName("lightLink_" + id);
        if (linkGraph) {
            linkGraph.destroy();
        }
        if (editLink) {
            editLink.destroy();
        }
        if (lightLink) {
            lightLink.destroy();
        }
        wio_currentCustomizer.jsonData.links = jQuery.grep(wio_currentCustomizer.jsonData.links, function (link) {
            if (link.id != id) {
                return link;
            }
        });
        updateLinks();
    }
    function updateSettings() {
        $('#wio_winSettings').find('[name]').each(function () {
            var name = $(this).attr('name');
            if ($(this).is('[type="checkbox"]')) {
                $(this).prop('checked', false);
            }
            if (wio_currentCustomizer.jsonData.settings[name]) {
                if ($(this).is('[type="checkbox"]')) {
                    $(this).prop('checked', true);
                } else {
                    $(this).val(wio_currentCustomizer.jsonData.settings[name]);
                }
            }

        });
        $('#wio_winSettings').find('[name="title"]').val(wio_currentCustomizer.jsonData.title);
        onSettingsModifypriceChange();
    }
    function onSettingsModifypriceChange() {
        if (!$('#wio_settings_modifyPrice').is(':checked')) {
            $('#wio_settings_optionsCostNextProductPrice,#wio_settings_pricesInResume,#wio_settings_totalInResume,#wio_settings_digitsSep,#wio_settings_thousandSep,#wio_settings_millionSep,#wio_settings_billionSep').closest('.row').addClass('wio_hidden');
        } else {
            $('#wio_settings_optionsCostNextProductPrice,#wio_settings_pricesInResume,#wio_settings_totalInResume,#wio_settings_digitsSep,#wio_settings_thousandSep,#wio_settings_millionSep,#wio_settings_billionSep').closest('.row').removeClass('wio_hidden');
        }
    }
    function showWinCalculationAddValue() {
        $('#wio_selectValueItem').html('');
        $('#wio_selectValueItem').append('<option value="total">' + wio_data.texts['Total price'] + '</option>');
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            var step = wio_currentCustomizer.jsonData.steps[i];
            for (var j = 0; j < step.items.length; j++) {
                var field = step.items[j];
                var attributes = getFieldAttributesTypes(field);
                if (attributes.length > 0) {
                    $('#wio_selectValueItem').append('<option value="' + field.id + '">' + field.label + '</option>');
                }
            }
        }
        onSelectValueItemChanged();
        $('#wio_winEditStepField').modal('hide');
        $('#wio_winSelectValue').modal('show');

    }
    function onSelectValueItemChanged() {
        var itemID = $('#wio_selectValueItem').val();
        var field = getField(itemID);
        $('#wio_selectValueAttribute').html('');
        if (field) {
            var attributes = getFieldAttributesTypes(field);
            for (var i = 0; i < attributes.length; i++) {
                var attribute = attributes[i];
                $('#wio_selectValueAttribute').append('<option value="' + attribute.type + '">' + attribute.name + '</option>');
            }
        }
    }
    function getFieldAttributesTypes(field) {
        var rep = new Array();
        if (field.type == 'numberfield' || field.type == 'textfield' || field.type == 'selectfield' || field.type == 'textarea') {
            rep.push({
                type: 'value',
                name: wio_data.texts['Value']
            });
        }
        return rep;
    }

    function generateFieldID() {
        wio_currentCustomizer.jsonData.currentFieldIndex = parseInt(wio_currentCustomizer.jsonData.currentFieldIndex);
        if (isNaN(wio_currentCustomizer.jsonData.currentFieldIndex)) {
            wio_currentCustomizer.jsonData.currentFieldIndex = 1;
        }
        wio_currentCustomizer.jsonData.currentFieldIndex++;
        return wio_currentCustomizer.jsonData.currentFieldIndex;
    }

    function insertCalcConditions() {
        var error = false;

        var rep = "\n" + 'if (';
        var operator = '&&';
        if (wio_currentCalcConditions.length > 0 && wio_currentCalcConditions[0].operator == 'or') {
            operator = '||';
        }
        for (var i = 0; i < wio_currentCalcConditions.length; i++) {
            var conditionGroup = wio_currentCalcConditions[i];
            if (wio_currentCalcConditions.length > 1) {
                rep += '(';
            }
            var operatorGroup = '&&';
            if(conditionGroup.operator == 'or'){
                operatorGroup = '||';
            }
            for (var j = 0; j < conditionGroup.conditions.length; j++) {
                var condition = conditionGroup.conditions[j];
                var attribute = 'value';
                var operatorTxt = '';

                if (!condition.startField || !condition.startStep) {
                    error = true;
                }
                var noValue = false;
                if (condition.operator == 'isEqualTo') {
                    operatorTxt = ' == ';
                } else if (condition.operator == 'isSuperiorTo') {
                    operatorTxt = ' < ';
                } else if (condition.operator == 'isInferiorTo') {
                    operatorTxt = ' < ';
                } else if (condition.operator == 'isDifferentThan') {
                    operatorTxt = ' == ';
                } else if (condition.operator == 'isSelected') {
                    attribute = 'isSelected';
                    noValue = true;
                } else if (condition.operator == 'isntSelected') {
                    attribute = 'isntSelected';
                    noValue = true;
                }
                rep += '[field-' + condition.startField + '_' + attribute + ']';

                if (!noValue && condition.endType == 'value') {
                    if (!condition.endValue) {
                        condition.endValue = 0;
                    }
                    var condValue = condition.endValue;
                    if(isNaN(condValue)){
                        condValue = "'"+condValue+"'";
                    }
                    rep += operatorTxt + ' ' + condValue;
                }
                if (condition.endType == 'field') {
                    rep += operatorTxt + '[field-' + condition.endField + '_value]';
                    if (!condition.endField) {
                        error = true;
                    }
                }

                if (j < conditionGroup.conditions.length - 1) {
                    rep += ' ' + operatorGroup + ' ';
                }
            }
            if (wio_currentCalcConditions.length > 1) {
                rep += ')';
                if (i < wio_currentCalcConditions.length - 1) {
                    rep += ' ' + operator + ' ';
                }
            }

        }
        rep += ') { [price] = 0 }';
        if (!error) {
            var doc = wio_calculationEditor.getDoc();
            var cursor = doc.getCursor();
            doc.replaceRange(rep, cursor);
            $('#wio_winEditStepField').modal('show');
            $('#wio_winEditLink').modal('hide');
            setTimeout(function () {
                wio_calculationEditor.refresh();
            }, 500);

        }

    }

    function insertCalculationValue() {
        var valueTxt = '';
        var itemID = $('#wio_selectValueItem').val();
        var attribute = $('#wio_selectValueAttribute').val();
        if (itemID) {
            valueTxt = '[field-' + itemID + '_' + attribute + ']';
        }
        if (itemID == 'total') {
            valueTxt = '[total]';
        }
        var doc = wio_calculationEditor.getDoc();
        var cursor = doc.getCursor();
        doc.replaceRange(valueTxt, cursor);

        setTimeout(function () {
            wio_calculationEditor.refresh();
        }, 500);
        wio_calculationEditor.refresh();
        $('#wio_winEditStepField').modal('show');
        $('#wio_winSelectValue').modal('hide');


    }
    
    function onEditFieldUseTooltipChange(){
        if ($('#wio_winEditStepField [name="useTooltip"]').is(':checked')) {
            $('#wio_editFieldTooltip').closest('.row').slideDown(250);
        } else {
            $('#wio_editFieldTooltip').closest('.row').slideUp(250);
        }
        
    }

    function onEditFieldUseCalculationChange() {
        if ($('#wio_winEditStepField [name="useCalculation"]').is(':checked')) {
            $('#wio_editFieldCalculationBloc').slideDown(250);
            $('#wio_editFieldPrice').closest('.row').slideUp(250);
            setTimeout(function () {
                wio_calculationEditor.refresh();
            }, 400);
        } else {
            $('#wio_editFieldCalculationBloc').slideUp(250);
            var pricesTypes = ['numberfield', 'checkbox', 'radio', 'button'];
            if (pricesTypes.indexOf($('#wio_winEditStepField [name="type"]').val()) > -1) {
                $('#wio_editFieldPrice').closest('.row').slideDown(250);
            } else {

                $('#wio_editFieldPrice').closest('.row').hide();
            }
        }
    }
    function onResize() {
        if ($('#adminmenuwrap').height() > $('#wio_section_customizerView').height()) {
            $('#wio_section_customizerView').css({
                height: $('#adminmenuwrap').height()
            });
        } else {
            $('#wio_section_customizerView').css({
                height: $(window).height()
            });
        }
    }
    function askSaveBeforeLeave(url) {
        $('#wio_toastSaveBeforeLeave').data('wio_url', url);
        $('#wio_toastSaveBeforeLeave').toast('show');

    }
    function saveAndLeave() {
        saveCustomizer(function () {
            var url = $('#wio_toastSaveBeforeLeave').data('wio_url');
            if (url && url.length > 0) {
                if (url == document.location.href) {
                    document.location.reload();
                } else {
                    document.location.href = url;

                }
            }
        });
    }
    function saveAndPreview() {
        saveCustomizer(function () {
            $('#wio_winPreview input').val('');
            $('#wio_winPreview').modal('show');
        });
    }
    function leave() {
        var url = $('#wio_toastSaveBeforeLeave').data('wio_url');
        if (url && url.length > 0) {
            document.location.href = url;
        }
    }
    function saveCustomizer(callback) {
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_saveCustomizer',
                customizerID: wio_currentCustomizer.id,
                customizerData: JSON.stringify(wio_currentCustomizer.jsonData)
            },
            success: function () {
                wio_modifsDone = false;
                if (typeof (callback) == 'function') {
                    callback();
                }
                $('.toast').toast('hide');
                $('#wio_toastSaved').toast('show');
            }
        });
    }
    function createCustomizer() {
        var newCustomizer = {
            title: wio_data.texts['My customizer'],
            currentFieldIndex: 1,
            imgConditions: new Array(),
            settings: {
                customJS: '',
                customCSS: '',
                useWPML: false,
                modifyPrice: true,
                pricesInResume: true,
                totalInResume: true,
                hideForm: false,
                titleFontSize: 28,
                centerContent: false,
                panelPadding: 20,
                modal: false,
                backgroundColor: '#ecf0f1',
                textColor: '#222f3e',
                buttonColor: '#00d2d3',
                buttonTxtColor: '#ffffff',
                buttonIcon: 'fas fa-wrench',
                btnsRadius: 3,
                nextStepIcon: 'fas fa-check',
                nextStepColor: '#00d2d3',
                nextStepTxtColor: '#ffffff',
                checkboxColor: '#00d2d3',
                fieldsColor: '#ffffff',
                fieldsTxtColor: '#333333',
                fieldsBorderColor: '#dcd7ca',
                fieldsBorderWidth: 1,
                errorColor: '#ff6b6b',
                fontSize: 16,
                resumeFontSize: 15,
                txtButtonLabel: wio_data.texts['Customize it !'],
                txtNextStepLabel: wio_data.texts['Continue'],
                txtOptionName: wio_data.texts['Option'],
                txtTotal: wio_data.texts['Total'],
                txtValue: wio_data.texts['Value'],
                txtPrice: wio_data.texts['Price'],
                resumeTitle: wio_data.texts['Selected options'],
                tableHeaderColor: '#00d2d3',
                tableHeaderTxtColor: '#ffffff',
                tableTxtColor: '#333333',
                tableBgColor: '#ffffff',
                otherBtnsColor: '#8395a7',
                otherBtnsTxtColor: '#ffffff',
                tableBorderColor: '#777777',
                googleFont: '',
                modifyMainProductPrice: false,
                maxFiles: 3,
                maxWeight: 5,
                allowedExtensions: '.jpg,.png,.zip'
            },
            steps: [{
                    id: generateID(),
                    start: true,
                    title: wio_data.texts['My step'],
                    position: [50, 50],
                    items: []
                }],
            links: []
        };
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_createCustomizer',
                customizerData: JSON.stringify(newCustomizer)
            },
            success: function (newID) {
                wio_customizers.push({id: newID, jsonData: newCustomizer});
                updateCustomizersList();
                editCustomizer(parseInt(newID));
            }
        });
    }
    function generateID() {

        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }
    function updateCustomizersList() {
        $('#wio_section_customizersList table tbody').html('');
        for (var i = 0; i < wio_customizers.length; i++) {
            var customizer = wio_customizers[i];
            var tr = $('<tr></tr>');
            tr.attr('data-id', customizer.id);
            tr.append('<td>' + customizer.jsonData.title + '</td>');
            var thAction = $('<td class="wio_tdAction"></td>');
            tr.append(thAction);
            var btnEdit = $('<a href="javascript:" class="btn btn-sm btn-primary btn-circle me-1" title="' + wio_data.texts['Edit'] + '"><i class="fas fa-pencil-alt"></i></a>');
            btnEdit.on('click', function () {
                editCustomizer(parseInt($(this).closest('tr').attr('data-id')));
            });
            var btnDuplicate = $('<a href="javascript:" class="btn btn-sm btn-secondary  btn-circle me-1" title="' + wio_data.texts['Duplicate'] + '"><i class="far fa-copy"></i></a>');
            btnDuplicate.on('click', function () {
                duplicateCustomizer(parseInt($(this).closest('tr').attr('data-id')));
            });
            var btnRemove = $('<a href="javascript:" class="btn btn-sm btn-danger  btn-circle me-0" title="' + wio_data.texts['Remove'] + '"><i class="far fa-trash-alt"></i></a>');
            btnRemove.on('click', function () {
                removeCustomizer(parseInt($(this).closest('tr').attr('data-id')));
            });
            btnEdit.tooltip({
                container: '.wio_root',
                placement: 'bottom'
            });
            btnDuplicate.tooltip({
                container: '.wio_root',
                placement: 'bottom'
            });
            btnRemove.tooltip({
                container: '.wio_root',
                placement: 'bottom'
            });
            thAction.append(btnEdit);
            thAction.append(btnDuplicate);
            thAction.append(btnRemove);

            $('#wio_section_customizersList table tbody').append(tr);
        }
    }
    function getCustomizer(id) {
        var rep = false;
        for (var i = 0; i < wio_customizers.length; i++) {
            if (wio_customizers[i].id == id) {
                rep = wio_customizers[i];
                break;
            }
        }
        return rep;
    }
    function editCustomizer(id) {
        
        $('.tooltip').remove();
        var customizer = getCustomizer(id);
        if (customizer) {
            wio_currentCustomizer = customizer;
            changeMainSection('wio_section_customizerView');
            updateSettings();

            updateCustomizerApp();
            $('#adminmenumain').hide();
            $('#wpcontent').css({marginLeft: 0});
            $('#wio_mainHeader,#adminmenu').addClass('wio_fixed');
            setTimeout(updateLinks, 500);
        }
    }
    function duplicateCustomizer(id) {
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_duplicateCustomizer',
                customizerID: id
            },
            success: function () {
                loadCustomizers();
            }
        });
    }
    function removeCustomizer(id) {
        $('#wio_toastRemoveCustomizer').data('customizerID', id);
        $('#wio_toastRemoveCustomizer').toast('show');
    }
    function confirmRemoveCustomizer() {
        $('#wio_toastRemoveCustomizer').toast('hide');
        var id = $('#wio_toastRemoveCustomizer').data('customizerID');
        wio_customizers = $.grep(wio_customizers, function (n, i) {
            return (n.id != id);
        });
        updateCustomizersList();
        $.ajax({
            url: ajaxurl,
            type: 'post',
            data: {
                action: 'wio_removeCustomizer',
                customizerID: id
            },
            success: function (newID) {

            }
        });
    }
    function changeMainSection(sectionID) {
        $('#wio_content > section').hide();
        $('#wio_content > #' + sectionID).show();
    }
    function initCustomizerApp() {
        PIXI.settings.RESOLUTION = 1;
        PIXI.settings.SCALE_MODE = PIXI.SCALE_MODES.NEAREST;
        wio_customizerApp = new PIXI.Application({
            transparent: true,
            antialias: true,
            width: 7000,
            height: 2000,
        });

        var bgCt = new PIXI.Container();
        bgCt.width = 7000;
        bgCt.height = 2000;
        bgCt.interactive = true;
        bgCt.on('mousemove', function (e) {
            wio_viewportMousePosition = e.data.global;
        });
        wio_customizerApp.stage.addChild(bgCt);

        $('#wio_stepsAppCanvas').append(wio_customizerApp.view);
        $('#wio_stepsAppCanvas canvas').attr('id', 'wio_customizerApp')
       // updateCanvas();
       

        wio_customizerApp.ticker.add((delta) => {
            if (wio_linkingFromStep) {
                updateCurrentLink();
            }
            updateLightsLinks(delta);
        });
        $('#wio_stepsAppCanvas canvas').contextmenu(function (e) {
            if (wio_linkingFromStep) {
                stopLinking();
            }
            e.preventDefault();
            return false;
        });
    }
    function updateCanvas(){
          if (wio_linkingFromStep) {
                updateCurrentLink();
            }
            updateLightsLinks(1);
         setTimeout(updateCanvas,30);
    }
    function getActionLinkByID(linkID) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
            if (wio_currentCustomizer.jsonData.links[i].id == linkID) {
                rep = wio_currentCustomizer.jsonData.links[i];
            }
        }
        return rep;
    }
    function updateCurrentLink() {
        updateLink({
            startStep: wio_linkingFromStep,
            endStep: false,
            id: 'tmp',
            conditions: {
                id: generateID(),
                operator: 'and',
                value: '',
                conditions: []
            }
        });
    }

    function getLink(id) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
            if (wio_currentCustomizer.jsonData.links[i].id == id) {
                rep = id;
                break;
            }
        }
        return rep;
    }

    function updateLinks() {

        wio_linkGradientIndex++;
        if (wio_linkGradientIndex >= 30) {
            wio_linkGradientIndex = 1;
        }

        if (typeof (wio_currentCustomizer.jsonData.links) != 'undefined') {
            for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
                var link = wio_currentCustomizer.jsonData.links[i];
                updateLink(link);
            }
        }
    }

    function updateLink(link) {

        var startStepBloc = $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]');
        var startStep = getStepByID(link.startStep);
        if (startStep) {

            var startPosition = {
                left: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"').position().left + 120,
                top: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]').position().top + $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]').outerHeight() / 2
            };
            if (!link.endStep) {
                startPosition = {
                    left: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"] .wio_stepAnchor').offset().left - $('#wio_stepsBlocs').offset().left + 24 / 2,
                    top: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"] .wio_stepAnchor').offset().top - $('#wio_stepsBlocs').offset().top + 24 / 2
                };
            }
            var endAction;
            var chkLink = true;
            if (!link.endStep) {
                var endPosition = {
                    left: wio_viewportMousePosition.x,
                    top: wio_viewportMousePosition.y
                };
            } else {
                var endStep = getStepByID(link.endStep);
                if (endStep) {
                    var endPosition = {
                        left: $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').position().left + 120,
                        top: $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').position().top + $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').outerHeight() / 2
                    };
                } else {
                    chkLink = false;
                }

            }
            if (chkLink) {
                var x1 = endPosition.left;
                var y1 = endPosition.top;
                var linkGraph = wio_customizerApp.stage.getChildByName("link_" + link.id);
                var editLinkBtn = wio_customizerApp.stage.getChildByName("editLink_" + link.id);
                if (!linkGraph) {
                    linkGraph = new PIXI.Graphics();
                    linkGraph.name = "link_" + link.id;
                    wio_customizerApp.stage.addChild(linkGraph);
                    wio_customizerApp.stage.setChildIndex(linkGraph, 0);
                    if (link.endStep) {
                        editLinkBtn = new PIXI.Graphics();
                        editLinkBtn.name = "editLink_" + link.id;
                        editLinkBtn.linkID = link.id;
                        editLinkBtn.buttonMode = true;
                        editLinkBtn.interactive = true;
                        editLinkBtn.beginFill(colorHexToInt("#2d3436"), 1);
                        editLinkBtn.drawCircle(0, 0, 14);
                        editLinkBtn.visible = true;
                        editLinkBtn.on('mouseover', function () {
                            this.alpha = 0.9;
                        });
                        editLinkBtn.on('mouseout', function () {
                            this.alpha = 1;
                        });
                        editLinkBtn.on('click', function () {
                            editLink(this.linkID);
                        });
                        var icon = PIXI.Sprite.from(wio_data.assetsUrl + '/img/edit_w.png');
                        icon.width = 12;
                        icon.height = 12;
                        icon.x = -6;
                        icon.y = -6;
                        editLinkBtn.addChild(icon);
                        wio_customizerApp.stage.addChild(editLinkBtn);
                        wio_customizerApp.stage.setChildIndex(editLinkBtn, 1);
                        if (typeof (link.title) != 'undefined' && link.title != '') {
                            var linkTitle = new PIXI.Text(link.title, new PIXI.TextStyle({fontSize: 14}));
                            linkTitle.name = "linkTitle_" + link.id;
                            linkTitle.anchor.set(0.5, 0);
                            linkTitle.y = 20;
                            editLink.addChild(linkTitle);
                        }
                    }
                }
                var dx = endPosition.left - startPosition.left;
                var dy = endPosition.top - startPosition.top;
                if (link.endStep) {
                    var bezierPos = getBezierXY(0.5, startPosition.left, startPosition.top, startPosition.left + dx * 0.33, startPosition.top, startPosition.left + dx * 0.67, endPosition.top, endPosition.left, endPosition.top);
                    editLinkBtn.x = bezierPos.x;
                    editLinkBtn.y = bezierPos.y;
                }
                linkGraph.clear();
                var color = colorHexToInt("#535c68");
                if (wio_hightlightedLinks.indexOf(link) > -1) {
                    color = colorHexToInt("#81ecec");
                } else if (wio_hightlightedActiveLinks.indexOf(link) > -1) {
                    color = colorHexToInt("#00d2d3");
                }
                linkGraph.lineStyle(3, color, 1);
                linkGraph.moveTo(startPosition.left, startPosition.top);

                linkGraph.bezierCurveTo(startPosition.left + dx * 0.33, startPosition.top, startPosition.left + dx * 0.67, endPosition.top, endPosition.left, endPosition.top);

                if (wio_customizerApp.stage.getChildByName("lightLink_" + link.id)) {
                    wio_customizerApp.stage.getChildByName("lightLink_" + link.id).destroy();
                }

                if (!wio_customizerApp.stage.getChildByName("lightLink_" + link.id)) {
                    var light = new PIXI.Graphics();
                    light.name = "lightLink_" + link.id;
                    var color = colorHexToInt("#535c68");
                    if (wio_hightlightedLinks.indexOf(link) > -1) {
                        color = colorHexToInt("#81ecec");
                    } else if (wio_hightlightedActiveLinks.indexOf(link) > -1) {
                        color = colorHexToInt("#00d2d3");

                    }

                    light.beginFill(color, 0.5);
                    light.drawCircle(0, 0, 8);
                    light.endFill();
                    light.x = startPosition.left;
                    light.y = startPosition.top;
                    wio_customizerApp.stage.addChild(light);
                }

            }
        }

    }



    function editLink(linkID) {
        wio_currentImgConditions = false;
        wio_currentLink = getActionLinkByID(linkID);
        $('#wio_linkConditionsList').html('');
        $('#wio_winEditLink [data-wioaction="insertConditions"]').hide();
        var startStep = getStepByID(wio_currentLink.startStep);
        var endStep = getStepByID(wio_currentLink.endStep);
        $('#wio_conditionLink_startStep').html(startStep.title);
        $('#wio_conditionLink_endStep').html(endStep.title);

        $('#wio_conditionLinkInfo').show();
        $('#wio_winEditLink .modal-title').html(wio_data.texts['Edit a link']);

        $('#wio_winEditLink [data-wioaction="deleteLink"]').show();

        if (wio_currentLink) {
            for (var i = 0; i < wio_currentLink.conditions.conditions.length; i++) {

                var chkGroup = true;
                var conditionGroup = wio_currentLink.conditions.conditions[i];
                if (chkGroup) {
                    addOptionConditionGroupRow(wio_currentLink.conditions.conditions[i], wio_currentLink.conditions.operator);
                }
            }
            $('#wio_winEditLink').modal('show');
        }
    }

    function showWinCalcConditions() {
        wio_currentLink = false;
        wio_currentImgConditions = false;
        wio_currentCalcConditions = new Array();
        $('#wio_linkConditionsList').html('');
        $('#wio_winEditLink [data-wioaction="insertConditions"]').show();
        $('#wio_winEditLink [data-wioaction="deleteLink"]').hide();
        $('#wio_conditionLinkInfo').hide();
        $('#wio_winEditLink .modal-title').html(wio_data.texts['Add a condition']);
        $('#wio_winEditLink').modal('show');
        $('#wio_winEditStepField').modal('hide');

    }
    function showWinDynamicImgConditions(imgID) {
        wio_currentImg = getDynamicImage(imgID);
        wio_currentImgConditions = wio_currentImg.conditions;
        wio_currentLink = false;
        $('#wio_linkConditionsList').html('');
        $('#wio_winEditLink [data-wioaction="insertConditions"]').hide();
        $('#wio_winEditLink [data-wioaction="deleteLink"]').hide();
        $('#wio_conditionLinkInfo').hide();
        $('#wio_winEditLink .modal-title').html(wio_data.texts['Add a condition']);
        $('#wio_winEditLink').modal('show');
        $('#wio_winEditStepField').modal('hide');
        $('#wio_winDynamicImg').modal('hide');
        if (wio_currentImgConditions) {
            for (var i = 0; i < wio_currentImgConditions.length; i++) {
                addOptionConditionGroupRow(wio_currentImgConditions[i], wio_currentImg.operator);
            }
        }
    }
    function getDynamicImage(imgID) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.imgConditions.length; i++) {
            if (wio_currentCustomizer.jsonData.imgConditions[i].id == imgID) {
                rep = wio_currentCustomizer.jsonData.imgConditions[i];
                break;
            }
        }
        return rep;
    }
    function colorHexToInt(hex) {
        return '0x' + hex.substr(1, hex.length);
    }
    function updateCustomizerApp() {
        var startID = '';
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            var step = wio_currentCustomizer.jsonData.steps[i];
            if (step.start) {
                startID = step.id;
            }
            var bloc = generateStepBloc(step);
            $('#wio_stepsBlocs').append(bloc);
            updateStepBlocFields(step);
        }
        if (startID != '' && $('.wio_stepBloc.wio_active').length == 0) {
            $('.wio_stepBloc[data-wiostepid="' + startID + '"]').addClass('wio_active');
            wio_hightlightedActiveLinks = getLinksByStep(startID);
            wio_currentStep = step;
        }
    }
    function startStepLink() {
        wio_linkingFromStep = $(this).closest('.wio_stepBloc').data('stepID');
        $(this).closest('.wio_stepBloc').addClass('wio_linkStartStep');

    }
    function setStepAsStart() {
        var stepID = $(this).closest('.wio_stepBloc').data('stepID');
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            var step = wio_currentCustomizer.jsonData.steps[i];
            if (step.id == stepID) {
                step.start = true;
            } else {
                step.start = false;
            }
        }
        $('.wio_stepBloc.wio_startStep').removeClass('wio_startStep');
        $(this).closest('.wio_stepBloc').addClass('wio_startStep');
    }
    function generateStepBloc(step) {
        var bloc = $('<div class="wio_stepBloc p-2"></div>');
        bloc.data('stepID', step.id);
        bloc.attr('data-wiostepid', step.id);
        bloc.append('<div class="wio_stepAnchorCt"></div>');
        bloc.find('.wio_stepAnchorCt').append('<a href="javascript:" class="wio_stepAnchor btn btn-sm btn-circle btn-dark text-white" title="' + wio_data.texts['Link to another step'] + '"><i class="fas fa-link"></i></a>');
        bloc.find('.wio_stepAnchorCt').append('<a href="javascript:" class="wio_stepStartFlag wio_btnStep btn btn-sm btn-circle btn-dark text-white" title="' + wio_data.texts['Define as start step'] + '"><i class="fas fa-flag"></i></a>');
        bloc.find('.wio_stepAnchorCt').append('<a href="javascript:" class="wio_stepDuplicateBtn wio_btnStep btn btn-sm btn-circle btn-dark text-white" title="' + wio_data.texts['Duplicate'] + '"><i class="fas fa-copy"></i></a>');
        bloc.find('.wio_stepAnchorCt').append('<a href="javascript:" class="wio_stepRemoveBtn wio_btnStep btn btn-sm btn-circle btn-danger text-white" title="' + wio_data.texts['Remove'] + '"><i class="fas fa-trash"></i></a>');

        bloc.find('.wio_stepStartFlag,.wio_stepAnchor,.wio_stepRemoveBtn').tooltip({
            container: '.wio_root',
            placement: 'right'
        });
        bloc.find('.wio_stepAnchor').on('click', startStepLink);
        bloc.find('.wio_stepStartFlag').on('click', setStepAsStart);
        bloc.find('.wio_stepDuplicateBtn').on('click', function () {
            duplicateStep($(this).closest('.wio_stepBloc').data('stepID'));
        });
        bloc.find('.wio_stepRemoveBtn').on('click', function () {
            removeStep($(this).closest('.wio_stepBloc').data('stepID'));
        });
        bloc.append('<div class="wio_stepBlocMin my-1 px-2"></div>');
        bloc.find('.wio_stepBlocMin').html(step.title);
        if (step.start) {
            bloc.addClass('wio_startStep');
        }

        bloc.append('<div class="wio_stepBlocFull wio_dark"></div>');
        bloc.find('.wio_stepBlocFull').append('<div class="input-group"><span class="input-group-text">' + wio_data.texts['Title'] + '</span><input type="text" name="title" class="form-control form-control-sm" id="wio_stepTitle_' + step.id + '" placeholder="' + wio_data.texts['My title'] + '" /></div>');

        var btnAdd = $('<a href="javascript:" class="btn btn-sm btn-circle btn-primary float-end" title="' + wio_data.texts['Add a new field'] + '"><i class="fas fa-plus"></i></a>');
        btnAdd.tooltip({
            container: '.wio_root'
        });
        btnAdd.on('click', function () {
            var step = getStepByID($(this).closest('.wio_stepBloc').data('stepID'));
            addStepField(step);
        });

        var titleCt = $('<div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-1 border-bottom"></div>');
        titleCt.append('<h6>' + wio_data.texts['Fields'] + ' :</h6>');
        titleCt.append(btnAdd);
        bloc.find('.wio_stepBlocFull').append(titleCt);
        bloc.find('[name="title"]').on('keyup change', function () {
            var stepID = $(this).closest('.wio_stepBloc').attr('data-wiostepid');
            $(this).closest('.wio_stepBloc').find('.wio_stepBlocMin').html($(this).val());
            var step = getStepByID(stepID);
            if (step) {
                step.title = $(this).val();
            }
            wio_modifsDone = true;
        });

        bloc.find('.wio_stepBlocFull').append('<table class="table table-sm wio_stepFields"><tbody></tbody></table>');

        bloc.find('.wio_stepBlocFull tbody').sortable({
            helper: function (e, tr) {
                var $originals = tr.children();
                var $helper = tr.clone();
                $helper.children().each(function (index)
                {
                    jQuery(this).width($originals.eq(index).width());
                });
                return $helper;
            },
            stop: function (event, ui) {
                $(this).closest('tbody').find('tr').each(function () {
                    var field = getField(jQuery(this).attr('data-id'));
                    if (field) {
                        field.sort = jQuery(this).index();
                    }
                });
            }
        });

        bloc.find('input[name],select[name],textarea[name]').each(function () {
            var name = $(this).attr('name');
            if (step[name]) {
                $(this).val(step[name]);
            }
        });

        bloc.draggable({
            containment: "parent",
            delay: 100,
            drag: function (event, ui) {
                if ($(this).find('.wio_hover').length > 0 || $(this).find('.ui-resizable-resizing').length > 0 || $(this).find('.CodeMirror-focused').length > 0) {
                    return false;
                }
                updateLinks();
            },
            stop: function (event, ui) {

                var step = getStepByID(ui.helper.attr('data-wiostepid'));
                if (step) {
                    step.position = [ui.position.left, ui.position.top];
                }
            }
        });
        bloc.on('click', function () {
            if (!wio_linkingFromStep) {
                wio_currentStep = getStepByID($(this).closest('.wio_stepBloc').data('stepID'));
                $('#wio_stepsBlocs .wio_stepBloc').removeClass('wio_active');
                $(this).closest('.wio_stepBloc').addClass('wio_active');
                wio_hightlightedActiveLinks = getLinksByStep(wio_currentStep.id);
                updateLinks();
            } else if (wio_linkingFromStep && wio_linkingFromStep != $(this).data('stepID')) {
                if (!doesLinkExists(wio_linkingFromStep, $(this).data('stepID'))) {
                    createNewLink(wio_linkingFromStep, $(this).data('stepID'));
                    stopLinking();
                }
            }
        });
        bloc.on('mouseenter', function () {
            wio_hightlightedLinks = getLinksByStep($(this).closest('.wio_stepBloc').data('stepID'));
            updateLinks();
        });
        bloc.on('mouseleave', function () {
            wio_hightlightedLinks = new Array();
            updateLinks();
        });

        bloc.css({
            left: step.position[0],
            top: step.position[1]
        });
        return bloc;
    }

    function getLinksByStep(stepID) {
        var rep = new Array();
        for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
            var link = wio_currentCustomizer.jsonData.links[i];
            if (link.startStep == stepID || link.endStep == stepID) {
                rep.push(link);
            }
        }
        return rep;
    }
    function createNewLink(fromStepID, toStepID) {
        wio_currentCustomizer.jsonData.links.push({
            id: generateID(),
            startStep: fromStepID,
            endStep: toStepID,
            conditions: {
                id: generateID(),
                value: '',
                operator: 'and',
                conditions: []
            }
        });
        updateLinks();
    }

    function getFieldNameFromType(type) {
        var name = '';
        switch (type) {
            case 'numberfield':
                name = 'Number field';
                break;
            case 'textfield':
                name = 'Text field';
                break;
            case 'checkbox':
                name = 'Checkbox';
                break;
            case 'datepicker':
                name = 'Datepicker';
                break;
            case 'selectfield':
                name = 'Select menu';
                break;
            case 'filefield':
                name = 'File field';
                break;
            case 'button':
                name = 'Button';
                break;
            case 'textarea':
                name = 'Text area';
                break;
            case 'radio':
                name = 'Radio';
                break;
            case 'richText':
                name = 'Text';
                break;
            case 'selectableImage':
                name = 'Selectable image';
                break;
            case 'color':
                name = 'Color';
                break;

            default:
                name = type;
                break;
        }
        return name;
    }
    function doesLinkExists(startStep, endStep) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
            var link = wio_currentCustomizer.jsonData.links[i];
            if (link.startStep == startStep && link.endStep == endStep) {
                rep = true;
            }
        }
        return rep;
    }
    function updateStepBlocFields(step) {
        var bloc = $('.wio_stepBloc[data-wiostepid="' + step.id + '"]');
        bloc.find('.wio_stepFields').find('tbody').html('');

        step.items.sort((a, b) => (a.sort > b.sort) ? 1 : ((b.sort > a.sort) ? -1 : 0));

        for (var i = 0; i < step.items.length; i++) {
            var item = step.items[i];
            var tr = $('<tr data-id="' + item.id + '"></tr>');
            tr.append('<td>' + item.label + '<div class="wio_stepFieldType  text-secondary">' + wio_data.texts[getFieldNameFromType(item.type)] + '</div></td>');
            var tdAction = $('<td class="wio_tdAction"></td>');

            var btnEdit = $('<a href="javascript:" class="btn btn-primary btn-sm btn-circle me-1" title="' + wio_data.texts['Edit'] + '"><i class="fas fa-pencil-alt"></i></a>');
            btnEdit.on('click', function () {
                var step = getStepByID($(this).closest('.wio_stepBloc').data('stepID'));
                editStepField(step, $(this).closest('tr').attr('data-id'));
            });
            var btnDuplicate = $('<a href="javascript:" class="btn btn-secondary btn-sm btn-circle me-1" title="' + wio_data.texts['Duplicate'] + '"><i class="fas fa-copy"></i></a>');
            btnDuplicate.on('click', function () {
                var step = getStepByID($(this).closest('.wio_stepBloc').data('stepID'));
                duplicateStepField(step, $(this).closest('tr').attr('data-id'));
            });
            var btnRemove = $('<a href="javascript:" class="btn btn-danger btn-sm btn-circle me-0" title="' + wio_data.texts['Remove'] + '"><i class="fas fa-trash-alt"></i></a>');
            btnRemove.on('click', function () {
                removeStepField($(this).closest('tr').attr('data-id'));
            });
            btnEdit.tooltip({
                container: '.wio_root'
            });
            btnDuplicate.tooltip({
                container: '.wio_root'
            });
            btnRemove.tooltip({
                container: '.wio_root'
            });
            tdAction.append(btnEdit);
            tdAction.append(btnDuplicate);
            tdAction.append(btnRemove);
            tr.append(tdAction);
            bloc.find('.wio_stepFields').find('tbody').append(tr);
        }

    }

    function getStepByID(id) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            if (wio_currentCustomizer.jsonData.steps[i].id == id) {
                rep = wio_currentCustomizer.jsonData.steps[i];
            }
        }
        return rep;
    }
    function getStepField(step, id) {
        var rep = false;
        for (var i = 0; i < step.items.length; i++) {
            if (step.items[i].id == id) {
                rep = step.items[i];
            }
        }
        return rep;
    }
    function getField(id) {
        var rep = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            var step = wio_currentCustomizer.jsonData.steps[i];
            for (var j = 0; j < step.items.length; j++) {
                if (step.items[j].id == id) {
                    rep = step.items[j];
                }
            }
        }
        return rep;
    }
    function editStepField(step, id) {
        var fieldData = getStepField(step, id);
        wio_currentStepField = fieldData;
        $('#wio_winEditStepField').data('fieldID', id);
        $('#wio_winEditStepField').find('[name]').val('').prop('checked', false);
        $('#wio_winEditStepField [name="textType"]').val('text');

        $('#wio_editFieldType').val('checkbox').trigger('change');
        if (fieldData) {

            if (fieldData.priceCalculation == '') {
                fieldData.priceCalculation = '[price] = 0';
            }

            wio_calculationEditor.setValue(fieldData.priceCalculation);
            setTimeout(function () {
                wio_calculationEditor.refresh();
            }, 500);
            
            $('#wio_winEditStepField [name="type"]').val(fieldData.type);
        onStepFieldTypeChanged();
            $('#wio_winEditStepField').find('[name]').each(function () {
                if (fieldData[$(this).attr('name')]) {
                    if ($(this).is('[type="checkbox"]')) {
                        $(this).prop('checked', true);
                    } else {
                        $(this).val(fieldData[$(this).attr('name')]);
                    }
                } else {
                    if ($(this).is('[type="checkbox"]')) {
                        $(this).prop('checked', false);
                    } else {
                        $(this).val('');
                    }
                }
            });
        } else {
            $('#wio_winEditStepField').find('[name="maxHeight"]').val(64);
            wio_calculationEditor.setValue('[price] = 0');
            setTimeout(function () {
                wio_calculationEditor.refresh();
            }, 500);
        }
        if (wio_currentCustomizer.jsonData.settings.modifyPrice) {
            $('#wio_editFieldPrice').closest('.row').removeClass('wio_hidden');
            $('#wio_editFieldUseCalculation').closest('.row').removeClass('wio_hidden');
            $('#wio_editFieldCalculationBloc').removeClass('wio_hidden');
        } else {
            $('#wio_editFieldPrice').closest('.row').addClass('wio_hidden');
            $('#wio_editFieldUseCalculation').closest('.row').addClass('wio_hidden');
            $('#wio_editFieldCalculationBloc').addClass('wio_hidden');
        }
        onEditFieldUseTooltipChange();
        onEditFieldUseCalculationChange();
        $('#wio_winEditStepField').modal('show');

        setTimeout(function () {
            wio_calculationEditor.refresh();
            $('#wio_editFieldText').trigger('change');
            $('#wio_editFieldTooltip').trigger('change');
        }, 500);
    }

    function removeStep(id) {
        wio_modifsDone = true;
        $('.tooltip').remove();
        for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
            var link = wio_currentCustomizer.jsonData.links[i];
            if (link.startStep == id || link.endStep == id) {
                var linkGraph = wio_customizerApp.stage.getChildByName("link_" + link.id);
                var editLink = wio_customizerApp.stage.getChildByName("editLink_" + link.id);
                var lightLink = wio_customizerApp.stage.getChildByName("lightLink_" + link.id);

                if (linkGraph) {
                    linkGraph.destroy();
                }
                if (editLink) {
                    editLink.destroy();
                }
                if (lightLink) {
                    lightLink.destroy();
                }
            }
        }
        wio_currentCustomizer.jsonData.links = $.grep(wio_currentCustomizer.jsonData.links, function (n, i) {
            return (n.startStep != id && n.endStep != id);
        });
        wio_currentCustomizer.jsonData.steps = $.grep(wio_currentCustomizer.jsonData.steps, function (n, i) {
            return (n.id != id);
        });
        $('.wio_stepBloc[data-wiostepid="' + id + '"]').remove();
        updateLinks();

    }
    function removeStepField(id) {
        $('.tooltip').remove();
        wio_modifsDone = true;
        wio_currentStep.items = $.grep(wio_currentStep.items, function (n, i) {
            return (n.id != id);
        });
        updateStepBlocFields(wio_currentStep);
    }
    function addStepField(step) {
        wio_modifsDone = true;
        editStepField(step, 0);
    }
    function onStepFieldTypeChanged() {
        $('#wio_winEditStepField [name="useCalculation"]').prop('checked', false).trigger('change');
        var type = $('#wio_editFieldType').val();
        $('#wio_winEditStepField [data-wiotypes]:not([data-wiotypes="' + type + '"]):not([data-wiotypes*="' + type + ',"]):not([data-wiotypes*=",' + type + '"])').hide();
        $('#wio_winEditStepField [data-wiotypes]:not([data-wiotypes="' + type + '"]):not([data-wiotypes*="' + type + ',"]):not([data-wiotypes*=",' + type + '"])').each(function () {

            if ($(this).find('[type="checkbox"]').length > 0) {
                $(this).find('[type="checkbox"]').prop('checked', false);
            }
        });

        $('#wio_winEditStepField [data-wiotypes="' + type + '"]').show();
        $('#wio_winEditStepField [data-wiotypes*="' + type + ',"]').show();
        $('#wio_winEditStepField [data-wiotypes*=",' + type + '"]').show();

        if (type == 'numberfield') {
            $('#wio_editFieldNoticeCalcQuantity').show();
        } else {
            $('#wio_editFieldNoticeCalcQuantity').hide();
        }

    }
    function saveStepField() {
        var error = false;

        $('#wio_winEditStepField .is-invalid').removeClass('is-invalid');
        if ($('#wio_winEditStepField [name="label"]').val().trim().length == 0) {
            error = true;
            $('#wio_winEditStepField [name="label"]').addClass('is-invalid');
        }

        if (!error) {
            if (!wio_currentStepField) {
                wio_currentStepField = {
                    id: generateFieldID(),
                    sort: 99
                }
                wio_currentStep.items.push(wio_currentStepField);
            }
            $('#wio_winEditStepField [name]').each(function () {
                if ($(this).is('[type="checkbox"]')) {
                    if ($(this).is(':checked')) {
                        wio_currentStepField[$(this).attr('name')] = true;

                    } else {
                        wio_currentStepField[$(this).attr('name')] = false;
                    }
                } else {
                    wio_currentStepField[$(this).attr('name')] = $(this).val();
                }
            });
            if ($('#wio_winEditStepField [name="allowedExtensions"]').val().trim().length > 0) {
                var allowedExtensions = $('#wio_winEditStepField [name="allowedExtensions"]').val();
                if (allowedExtensions.indexOf(',') > -1) {
                    allowedExtensions = allowedExtensions.split(',');
                    for (var i = 0; i < allowedExtensions.length; i++) {
                        var ext = allowedExtensions[i].trim();
                        if (ext.indexOf('.') != 0) {
                            ext = '.' + ext;
                            allowedExtensions[i] = ext;
                        }
                    }

                }
                wio_currentStepField.allowedExtensions = allowedExtensions.join(',');
            } else {
                wio_currentStepField.allowedExtensions = '.jpg,.png,.zip';
            }

            wio_currentStepField.type = $('#wio_editFieldType').val();

            wio_currentStepField.priceCalculation = wio_calculationEditor.getValue();
            wio_currentStepField.priceCalculation = wio_currentStepField.priceCalculation.replace(/"/g, "'");
            $('#wio_winEditStepField').modal('hide');
            updateStepBlocFields(wio_currentStep);
            wio_modifsDone = true;
        }
    }

    function addStep() {
        var posX = jQuery('#wio_section_customizerView').scrollLeft() + jQuery('#wio_content').width() / 2 + Math.floor(Math.random() * 100);
        var posY = jQuery('#wio_section_customizerView').scrollTop() + jQuery('#wio_content').height() / 2 + Math.floor(Math.random() * 100);

        wio_modifsDone = true;
        if (posX < 48) {
            posX = 48;
        }
        if (posY < 78) {
            posY = 78;
        }
        var stepData = {
            id: generateID(),
            start: false,
            title: wio_data.texts['My step'],
            position: [posX, posY],
            items: []
        };
        var startStepExists = false;
        for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
            if (wio_currentCustomizer.jsonData.steps[i].start) {
                startStepExists = true;
                break;
            }
        }
        if (!startStepExists) {
            stepData.start = true;
        }
        wio_currentCustomizer.jsonData.steps.push(stepData);

        var bloc = generateStepBloc(stepData);
        $('#wio_stepsBlocs').append(bloc);
        updateStepBlocFields(stepData);
        bloc.trigger('click');

    }


    function stopLinking() {
        wio_linkingFromStep = 0;
        $('.wio_stepBloc.wio_linkStartStep').removeClass('wio_linkStartStep');
        var linkGraph = wio_customizerApp.stage.getChildByName("link_tmp");
        var light = wio_customizerApp.stage.getChildByName("lightLink_tmp");
        if (linkGraph) {
            linkGraph.destroy();
        }
        updateLinks();
        if (light) {
            light.destroy();
        }
    }

    function getBezierXY(t, sx, sy, cp1x, cp1y, cp2x, cp2y, ex, ey) {
        return {
            x: Math.pow(1 - t, 3) * sx + 3 * t * Math.pow(1 - t, 2) * cp1x
                    + 3 * t * t * (1 - t) * cp2x + t * t * t * ex,
            y: Math.pow(1 - t, 3) * sy + 3 * t * Math.pow(1 - t, 2) * cp1y
                    + 3 * t * t * (1 - t) * cp2y + t * t * t * ey
        };
    }
    function getQBezierValue(t, p1, p2, p3) {
        var iT = 1 - t;
        return iT * iT * p1 + 2 * iT * t * p2 + t * t * p3;
    }

    function addOptionConditionGroup() {
        var conditionGroup = {
            id: generateID(),
            operator: 'and',
            conditions: []
        };
        var targetArray = new Array();
        var operator = 'and';
        if (wio_currentImgConditions) {
            targetArray = wio_currentImgConditions;
            operator = wio_currentImg.operator;
        } else if (wio_currentLink) {
            targetArray = wio_currentLink.conditions.conditions;
            operator = wio_currentLink.conditions.operator;
        } else {
            targetArray = wio_currentCalcConditions;
        }
        targetArray.push(conditionGroup);
        addOptionConditionGroupRow(conditionGroup, operator);
    }
    function addOptionConditionGroupRow(conditionGroup, operator) {
        if ($('#wio_linkConditionsList .wio_conditionGroup ').length > 0) {
            var $link = $('<div class="wio_conditionsLink p-3"></div>');
            $link.append('<select class="form-control wio_conditionsGroupLinkOperator"><option value="and">' + wio_data.texts['And'] + '</option><option value="or">' + wio_data.texts['Or'] + '</option></select>');
            $('#wio_linkConditionsList').append($link);
            $link.find('.wio_conditionsGroupLinkOperator').val(operator);
            $link.find('.wio_conditionsGroupLinkOperator').on('change', function () {
                updateOptionConditionsData();
            });
        }
        var $bloc = $('<div class="wio_conditionGroup p-3" data-id="' + conditionGroup.id + '"></div>');
        var $btnContainer = $('<div class="text-center mb-2"></div>');
        $btnContainer.append('<a href="javascript:" data-action="addCondition" class="btn btn-sm btn-secondary me-1"><i class="fas fa-plus-circle me-2"></i>' + wio_data.texts['Add a condition'] + '</a>');
        $btnContainer.append('<a href="javascript:" data-action="deleteConditionGroup" class="btn  btn-sm btn-danger me-1"><i class="fas fa-trash me-2"></i>' + wio_data.texts['Delete the group'] + '</a>');
        $bloc.append($btnContainer);
        $('#wio_linkConditionsList').append($bloc);
        $bloc.find('a[data-action="addCondition"]').on('click', function () {
            addOptionCondition(conditionGroup);
        });
        $bloc.find('a[data-action="deleteConditionGroup"]').on('click', function () {
            deleteConditionGroup(conditionGroup);
        });
        for (var i = 0; i < conditionGroup.conditions.length; i++) {
            addOptionConditionBlocRow(conditionGroup.conditions[i], conditionGroup);
        }

    }
    function deleteConditionGroup(conditionGroup) {
        if ($('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').prev('.wio_conditionsLink').length > 0) {
            $('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').prev('.wio_conditionsLink').remove();
        }
        if ($('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').index() == 0 && $('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').next('.wio_conditionsLink').length > 0) {

            $('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').next('.wio_conditionsLink').remove();
        }
        $('#wio_linkConditionsList .wio_conditionGroup[data-id="' + conditionGroup.id + '"]').remove();
        updateOptionConditionsData();
    }

    function updateOptionConditionsData() {
        wio_modifsDone = true;
        var targetArray = wio_currentCalcConditions;
        if (wio_currentLink) {
            targetArray = wio_currentLink.conditions.conditions;
        } else if (wio_currentImgConditions) {
            targetArray = wio_currentImgConditions;
        }
        targetArray = new Array();
        $('#wio_linkConditionsList .wio_conditionGroup').each(function () {
            var $group = $(this);

            var conditions = new Array();
            var conditionOperator = 'and';
            if ($group.find('.wio_conditionsLinkOperator').length > 0) {
                conditionOperator = $group.find('.wio_conditionsLinkOperator').val();
            }

            $group.find('.wio_condition').each(function () {
                var $condition = $(this);
                conditions.push({
                    id: $condition.attr('data-id'),
                    startStep: $condition.find('[name="startStep"]').val(),
                    startType: $condition.find('[name="startType"]').val(),
                    startField: $condition.find('[name="startField"]').val(),
                    endType: $condition.find('[name="endType"]').val(),
                    endStep: $condition.find('[name="endStep"]').val(),
                    endValue: $condition.find('[name="endValue"]').val(),
                    endField: $condition.find('[name="endField"]').val(),
                    operator: $condition.find('[name="operator"]').val()
                });
            });
            var conditionGroup = {
                id: $group.attr('data-id'),
                conditions: conditions,
                operator: conditionOperator
            };
            targetArray.push(conditionGroup);
        });
        var operator = 'and';
        if ($('#wio_linkConditionsList > .wio_conditionsLink').length > 0) {
            operator = $('#wio_linkConditionsList > .wio_conditionsLink .wio_conditionsGroupLinkOperator').val();
        } else {
        }
        if (wio_currentImgConditions) {
            wio_currentImgConditions = targetArray;
            wio_currentImg.conditions = targetArray;
            wio_currentImg.operator = operator;
        } else if (!wio_currentLink) {
            wio_currentCalcConditions = targetArray;
        } else {
            wio_currentLink.conditions.conditions = targetArray;
            wio_currentLink.conditions.operator = operator;
        }
    }
    function addOptionCondition(conditionGroup) {
        var condition = {
            id: generateID(),
            startStep: '',
            startType: 'field',
            endType: 'value',
            endElement: '',
            endStep: '',
            endValue: ''
        };
        conditionGroup.conditions.push(condition);
        var conditionBloc = addOptionConditionBlocRow(condition, conditionGroup);
        // conditionBloc.addClass('wio_addedBloc');
        setTimeout(updateOptionConditionsData, 400);
        /*setTimeout(function () {
         conditionBloc.removeClass('wio_addedBloc');
         }, 300);*/
    }
    function getConditionGroupByID(conditionsGroupID) {
        var rep = false;

        var targetArray = wio_currentCalcConditions;
        if (wio_currentLink) {
            targetArray = wio_currentLink.conditions.conditions;
        } else if (wio_currentImgConditions) {
            targetArray = wio_currentImgConditions;
        }
        for (var i = 0; i < targetArray.length; i++) {
            if (targetArray[i].id == conditionsGroupID) {
                rep = targetArray[i];
                break;
            }
        }
        return rep;
    }
    function getConditionFromGroup(conditionID, group) {
        var rep = false;
        for (var i = 0; i < group.conditions.length; i++) {
            if (group.conditions[i].id == conditionID) {
                rep = group.conditions[i];
                break;
            }
        }
        return rep;
    }
    function addOptionConditionBlocRow(condition, conditionGroup) {
        var delayShow = 200;
        if ($('.wio_conditionGroup[data-id="' + conditionGroup.id + '"]').find('.wio_condition').length > 0) {
            var $link = $('<div class="wio_conditionsLink px-3 px-2 py-2"></div>');
            var $linkOperator = $('<select class="form-control wio_conditionsLinkOperator"><option value="and">' + wio_data.texts['And'] + '</option><option value="or">' + wio_data.texts['Or'] + '</option></select>');
            if ($('.wio_conditionGroup[data-id="' + conditionGroup.id + '"] .wio_conditionsLinkOperator').length > 0) {
            }
            $linkOperator.val(conditionGroup.operator);
            $link.append($linkOperator);
            $('.wio_conditionGroup[data-id="' + conditionGroup.id + '"]').append($link);

            $link.find('.wio_conditionsLinkOperator').on('change', function () {
                $(this).closest('.wio_conditionGroup').find('.wio_conditionsLinkOperator').val($(this).val());
                updateOptionConditionsData();
            });
            $link.hide();
            setTimeout(function () {
                $link.slideDown();
            }, 100);
            delayShow = 400;
        }

        var $bloc = $('<div class="wio_condition" data-id="' + condition.id + '"></div>');
        $bloc.append('<select name="startType" title="' + wio_data.texts['Type'] + '" class="form-control wio_hidden"><option value="field" selected>Field</option></select>');
        $bloc.append('<select name="startStep" title="' + wio_data.texts['Step'] + '" class="form-control"></select>');
        $bloc.append('<select name="startField" title="' + wio_data.texts['Field'] + '" class="form-control"></select>');
        $bloc.append('<select name="operator"  title="' + wio_data.texts['Operator'] + '" class="form-control"></select>');
        $bloc.append('<select name="endType" title="' + wio_data.texts['Type'] + '" class="form-control"></select>');
        $bloc.append('<select name="endStep" title="' + wio_data.texts['Step'] + '" class="form-control"></select>');
        $bloc.append('<select name="endField" title="' + wio_data.texts['Field'] + '" class="form-control"></select>');
        $bloc.append('<input type="number" name="endValue" title="' + wio_data.texts['Value'] + '" class="form-control" />');
        $bloc.append('<a href="javascript:" data-action="deleteConditionBloc" class="btn btn-sm btn-danger btn-circle"><i class="fas fa-trash"></i></a>');
        $bloc.hide();
        setTimeout(function () {
            $bloc.slideDown();
        }, delayShow);

        $('.wio_conditionGroup[data-id="' + conditionGroup.id + '"]').append($bloc);
        $bloc.find('select[title]').tooltip({
            container: '.wio_root'
        });

        initConditionStepSelect($bloc.find('[name="startStep"]'), condition);
        setTimeout(function () {
            initOptionConditionFieldsSelect($bloc.find('[name="startField"]'), condition);
        }, 50);
        initOptionConditionOperatorSelect($bloc.find('[name="operator"]'), condition);
        initOptionConditionTypeSelect($bloc.find('[name="endType"]'), true, condition);
        initConditionStepSelect($bloc.find('[name="endStep"]'), condition);
        initOptionConditionFieldsSelect($bloc.find('[name="endField"]'), condition);

        if (typeof (condition.endValue) != 'undefined') {
            setTimeout(function () {
                $bloc.find('[name="endValue"]').val(condition.endValue).trigger('change');
            }, 100);
        }

        $bloc.find('[data-action="deleteConditionBloc"]').on('click', function () {

            var targetConditions = wio_currentCalcConditions;
            if (wio_currentLink) {
                targetConditions = wio_currentLink.conditions;
            } else if (wio_currentImgConditions) {
                targetConditions = wio_currentImgConditions;
            }
            var groupID = $(this).closest('.wio_conditionGroup').attr('data-id');
            var conditionID = $(this).closest('.wio_condition').attr('data-id');
            for (var i = 0; i < targetConditions.length; i++) {
                if (targetConditions[i].id == groupID) {

                    var group = targetConditions[i];
                    group.conditions = jQuery.grep(group.conditions, function (exCondition) {
                        if (exCondition.id != conditionID) {
                            return exCondition;
                        }
                    });

                    break;
                }
            }

            var conditionLink = false;
            var conditionBloc = $(this).closest('.wio_condition');
            if ($(this).closest('.wio_condition').parent().children('.wio_condition').index($(this).closest('.wio_condition')) > 0) {
                if ($(this).closest('.wio_condition').prev('.wio_conditionsLink').length > 0) {
                    conditionLink = $(this).closest('.wio_condition').prev('.wio_conditionsLink');
                } else if ($(this).closest('.wio_condition').next('.wio_conditionsLink').length > 0) {
                    conditionLink = $(this).closest('.wio_condition').next('.wio_conditionsLink');
                }
            }
            if (conditionLink) {
                conditionLink.slideUp(250);
                conditionBloc.slideUp(250);
                setTimeout(function () {
                    conditionBloc.remove();
                    conditionLink.remove();
                    updateOptionConditionsData();
                }, 250);
            } else {
                conditionBloc.slideUp(250);
                setTimeout(function () {
                    conditionBloc.remove();
                    updateOptionConditionsData();
                }, 250);
            }
            /*  if ($(this).closest('.wio_condition').parent().children('.wio_condition').index($(this).closest('.wio_condition')) > 0) {
             $(this).closest('.wio_condition').prev('.wio_conditionsLink').slideUp(250);
             setTimeout(function () {
             $(this).closest('.wio_condition').prev('.wio_conditionsLink').remove();
             }, 250);
             // $(this).closest('.wio_condition').prev('.wio_conditionsLink').remove();
             } else {
             $(this).closest('.wio_condition').next('.wio_conditionsLink').slideUp(250);
             setTimeout(function () {
             $(this).closest('.wio_condition').next('.wio_conditionsLink').remove();
             }, 250);
             //  $(this).closest('.wio_condition').next('.wio_conditionsLink').remove();
             }
             
             $(this).closest('.wio_condition').slideUp(250);
             setTimeout(function () {
             $(this).closest('.wio_condition').remove();
             }, 250);*/
        });

        $bloc.find('[name="startStep"]').on('change', function () {
            initOptionConditionFieldsSelect($(this).closest('.wio_condition').find('[name="startField"]'));
        });
        $bloc.find('[name="startField"]').on('change', function () {
            initOptionConditionOperatorSelect($(this).closest('.wio_condition').find('[name="operator"]'));
            $(this).closest('.wio_condition').find('[name="operator"]').trigger('change');
        });
        $bloc.find('[name="operator"]').on('change', function () {
            var valueType = $(this).find('option:selected').attr('data-valuetype');
            if (valueType == 'false') {
                $(this).closest('.wio_condition').find('[name="endType"]').val('value').hide();
                $(this).closest('.wio_condition').find('[name="endStep"]').hide();
                $(this).closest('.wio_condition').find('[name="endField"]').hide();
                $(this).closest('.wio_condition').find('[name="endValue"]').hide();
            } else {
                $(this).closest('.wio_condition').find('[name="endType"]').show();
                $(this).closest('.wio_condition').find('[name="endStep"]').show();
                $(this).closest('.wio_condition').find('[name="endField"]').show();
                initOptionConditionFieldsSelect($(this).closest('.wio_condition').find('[name="endField"]'));
                initConditionStepSelect($(this).closest('.wio_condition').find('[name="endStep"]'));
            }

        });


        $bloc.find('[name="endType"]').on('change', function () {
            initOptionConditionElementSelect($(this).closest('.wio_condition').find('[name="endStep"]'));
            $(this).closest('.wio_condition').find('[name="endStep"]').trigger('change');
        });

        $bloc.find('[name="endStep"]').on('change', function () {
            initOptionConditionFieldsSelect($(this).closest('.wio_condition').find('[name="endField"]'));
            $(this).closest('.wio_condition').find('[name="endField"]').trigger('change');
        });
        setTimeout(function () {
            $bloc.find('.form-control').on('change', updateOptionConditionsData);
        }, 800);
        return $bloc;
    }

    function initConditionStepSelect($select, condition) {
        $select.html('');
        var originalSelectValue = 'field';
        if ($select.is('[name="endStep"]')) {
            originalSelectValue = $select.closest('.wio_condition').find('[name="endType"]').val();
        }
        if (originalSelectValue == 'field') {
            $select.attr('data-original-title', wio_data.texts['View']);
            for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
                var element = wio_currentCustomizer.jsonData.steps[i];
                var chkField = false;
                for (var j = 0; j < element.items.length; j++) {
                    if (getConditionsOperatorsByValueType(element.items[j].type).length > 0) {
                        chkField = true;
                        break;
                    }
                }
                if (chkField) {
                    $select.append('<option value="' + element.id + '">' + element.title + '</option>');
                }

            }
            if ($select.is('[name="endStep"]')) {
                $select.closest('.wio_condition').find('[name="endValue"]').hide();
                $select.closest('.wio_condition').find('[name="endStep"]').show();
                $select.closest('.wio_condition').find('[name="endField"]').show();
            } else {
                $select.closest('.wio_condition').find('[name="startValue"]').hide();
                $select.closest('.wio_condition').find('[name="startStep"]').show();
                $select.closest('.wio_condition').find('[name="startField"]').show();
            }
        } else if (originalSelectValue == 'value') {
            $select.attr('data-original-title', wio_data.texts['Value']);
            if ($select.is('[name="endStep"]')) {
                $select.closest('.wio_condition').find('[name="endStep"]').hide();
                $select.closest('.wio_condition').find('[name="endField"]').hide();
                $select.closest('.wio_condition').find('[name="endValue"]').show();
                var valueType = $select.closest('.wio_condition').find('[name="operator"] option:selected').attr('data-valuetype');
                if (valueType == 'text') {
                    $select.closest('.wio_condition').find('[name="endValue"]').prop('type', 'text');
                } else if (valueType == 'number') {
                    $select.closest('.wio_condition').find('[name="endValue"]').prop('type', 'number');
                }

            } else {
                $select.closest('.wio_condition').find('[name="startStep"]').hide();
                $select.closest('.wio_condition').find('[name="startValue"]').show();
                $select.closest('.wio_condition').find('[name="startField"]').hide();
            }
        }

        if (typeof (condition) != 'undefined') {
            if (condition[$select.attr('name')] != '') {
                $select.val(condition[$select.attr('name')]).trigger('change');
            } else {
                if ($select.find('option').length > 0) {
                    $select.val($select.find('option').first().attr('value'));
                }
            }
        }

    }


    function initOptionConditionFieldsSelect($select, condition) {
        $select.html('');
        var typeSelectName = 'startType';
        var actionSelectName = 'startStep';
        if ($select.is('[name="endField"]')) {
            typeSelectName = 'endType';
            actionSelectName = 'endStep';
        }
        if ($select.closest('.wio_condition').find('[name="' + typeSelectName + '"]').val() == 'field') {
            var stepID = $select.closest('.wio_condition').find('[name="startStep"]').val();
            if ($select.attr('name') == 'endField') {
                stepID = $select.closest('.wio_condition').find('[name="endStep"]').val();
            }

            var step = getStepByID(stepID);
            if (step) {

                for (var i = 0; i < step.items.length; i++) {
                    var item = step.items[i];
                    var conditionsOp = getConditionsOperatorsByValueType(item.type);
                    if (conditionsOp.length > 0) {
                        $select.append('<option value="' + item.id + '">' + item.label + '</option>');
                    }
                }

            }
        }
        if ($select.is('[name="startField"]')) {
            if (typeof (condition) != 'undefined' && getField(condition[$select.attr('name')])) {
                $select.val(condition[$select.attr('name')]).trigger('change');
                initOptionConditionOperatorSelect($select.closest('.wio_condition').find('[name="operator"]'));
            } else {
                if ($select.find('option').length > 0) {
                    $select.val($select.find('option').first().attr('value')).trigger('change');
                    initOptionConditionOperatorSelect($select.closest('.wio_condition').find('[name="operator"]'));
                }
            }
        }

    }


    function initOptionConditionOperatorSelect($select, condition) {
        $select.html('');
        if ($select.closest('.wio_condition').find('[name="startType"]').val() == 'field') {
            var elementID = $select.closest('.wio_condition').find('[name="startStep"]').val();
            var itemID = $select.closest('.wio_condition').find('[name="startField"]').val();
            var item = getField(itemID);
            if (item) {
                var conditionsOp = getConditionsOperatorsByValueType(item.type);
                for (var i = 0; i < conditionsOp.length; i++) {
                    var conditionOp = conditionsOp[i];
                    $select.append('<option value="' + conditionOp.id + '" data-valuetype="' + conditionOp.valueType + '">' + conditionOp.text + '</option>');

                }
            }
        }
        setTimeout(function () {
            if (typeof (condition) != 'undefined') {
                if (condition.operator != '') {
                    $select.val(condition.operator).trigger('change');
                } else {
                    if ($select.find('option').length > 0) {
                    }
                }

            } else {
                if ($select.find('option').length > 0) {
                }
            }
            $select.trigger('change');
        }, 100);
    }
    function initOptionConditionTypeSelect($select, allowValue, condition) {
        $select.html('');
        if (allowValue) {
            $select.append('<option value="value">' + wio_data.texts['Value'] + '</option>');
        }
        $select.append('<option value="field">' + wio_data.texts['Field'] + '</option>');
        setTimeout(function () {
            if (typeof (condition) != 'undefined') {

                if ($select.closest('.wio_condition').find('[name="operator"] option:selected').is('[data-valuetype="false"]')) {
                    $select.val('value').trigger('change');
                } else {
                    $select.val(condition.endType).trigger('change');
                }
            }
        }, 100);
    }
    function initOptionConditionElementSelect($select, condition) {
        $select.html('');
        var originalSelectName = 'startType';
        if ($select.is('[name="endStep"]')) {
            originalSelectName = 'endType';
        }
        if ($select.closest('.wio_condition').find('[name="' + originalSelectName + '"]').val() == 'field') {
            $select.attr('data-original-title', wio_data.texts['Step']);
            for (var i = 0; i < wio_currentCustomizer.jsonData.steps.length; i++) {
                var element = wio_currentCustomizer.jsonData.steps[i];
                $select.append('<option value="' + element.id + '">' + element.title + '</option>');
            }
            if ($select.is('[name="endStep"]')) {
                $select.closest('.wio_condition').find('[name="endValue"]').hide();
                $select.closest('.wio_condition').find('[name="endStep"]').show();
                $select.closest('.wio_condition').find('[name="endField"]').show();
            } else {
                $select.closest('.wio_condition').find('[name="startValue"]').hide();
                $select.closest('.wio_condition').find('[name="startStep"]').show();
                $select.closest('.wio_condition').find('[name="startField"]').show();
            }
        } else if ($select.closest('.wio_condition').find('[name="' + originalSelectName + '"]').val() == 'value') {
            $select.attr('data-original-title', wio_data.texts['Value']);
            if ($select.is('[name="endStep"]')) {
                $select.closest('.wio_condition').find('[name="endStep"]').hide();
                $select.closest('.wio_condition').find('[name="endField"]').hide();
                $select.closest('.wio_condition').find('[name="endValue"]').show();
                var valueType = $select.closest('.wio_condition').find('[name="operator"] option:selected').attr('data-valuetype');
                if (valueType == 'text') {
                    $select.closest('.wio_condition').find('[name="endValue"]').prop('type', 'text');
                } else if (valueType == 'number') {
                    $select.closest('.wio_condition').find('[name="endValue"]').prop('type', 'number');
                }

            } else {
                $select.closest('.wio_condition').find('[name="startStep"]').hide();
                $select.closest('.wio_condition').find('[name="startValue"]').show();
                $select.closest('.wio_condition').find('[name="startField"]').hide();
            }

        }

        if (typeof (condition) != 'undefined') {
            $select.val(condition[$select.attr('name')]).trigger('change');
        }

    }

    function getConditionsOperatorsByValueType(valueType) {
        var operators = [];
        switch (valueType) {
            case "checkbox":
            case "radio":
            case "button":
                operators = [{
                        id: 'isSelected',
                        text: wio_data.texts["Is selected"],
                        valueType: false,
                        checkCondition: function ($element) {
                            if ($element.is(':checked')) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }, {
                        id: 'isntSelected',
                        text: wio_data.texts["Isn't selected"],
                        valueType: false,
                        checkCondition: function ($element) {
                            if (!$element.is(':checked')) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }]
                break;
            case "selectfield":
            case "color":
                operators = [
                    {
                        id: 'isEqualTo',
                        text: wio_data.texts["Is equal to"],
                        valueType: 'text',
                        checkCondition: function ($element, value) {
                            if ($element.find('input[type="number"]').val() == value) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }, {
                        id: 'isDifferentThan',
                        text: wio_data.texts["Is different than"],
                        valueType: 'text',
                        checkCondition: function ($element, value) {
                            if ($element.find('input[type="number"]').val() == value) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }];
                break;
            case "textfield":
                operators = [{
                        id: 'isFilled',
                        text: wio_data.texts["Is filled"],
                        valueType: false,
                        checkCondition: function ($element) {
                            if ($element.is('.wio_filled')) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }, {
                        id: 'isntFilled',
                        text: wio_data.texts["Isn't filled"],
                        valueType: false,
                        checkCondition: function ($element) {
                            if ($element.is('.wio_filled')) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }, {
                        id: 'isEqualTo',
                        text: wio_data.texts["Is equal to"],
                        valueType: 'text',
                        checkCondition: function ($element, value) {
                            if ($element.find('input[type="number"]').val() == value) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }, {
                        id: 'isDifferentThan',
                        text: wio_data.texts["Is different than"],
                        valueType: 'text',
                        checkCondition: function ($element, value) {
                            if ($element.find('input[type="number"]').val() == value) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    }];
                break;
            case "numberfield":
                operators = [
                    {
                        id: 'isEqualTo',
                        text: wio_data.texts["Is equal to"],
                        valueType: 'number'
                    }, {
                        id: 'isDifferentThan',
                        text: wio_data.texts["Is different than"],
                        valueType: 'number'
                    }, {
                        id: 'isSuperiorTo',
                        text: wio_data.texts["Is superior to"],
                        valueType: 'number'
                    }, {
                        id: 'isInferiorTo',
                        text: wio_data.texts["Is inferior to"],
                        valueType: 'number'
                    }];
                break;
        }
        return operators;
    }

    function saveSettings() {
        $('#wio_winSettings').find('[name]').each(function () {
            var name = $(this).attr('name');
            if (name == 'title') {
                wio_currentCustomizer.jsonData.title = $(this).val();
            } else {
                if ($(this).is('[type="checkbox"]')) {
                    if ($(this).is(':checked')) {
                        wio_currentCustomizer.jsonData.settings[name] = true;
                    } else {
                        wio_currentCustomizer.jsonData.settings[name] = false;
                    }
                } else {
                    wio_currentCustomizer.jsonData.settings[name] = $(this).val();
                }
            }
        });
        $('#wio_winSettings').modal('hide');
        wio_modifsDone = true;
    }

    function updateLightsLinks(delta) {
        if (wio_currentCustomizer && typeof (wio_currentCustomizer.jsonData) != 'undefined' && typeof (wio_currentCustomizer.jsonData.links) != 'undefined') {
            for (var i = 0; i < wio_currentCustomizer.jsonData.links.length; i++) {
                var link = wio_currentCustomizer.jsonData.links[i];
                var light = wio_customizerApp.stage.getChildByName("lightLink_" + link.id);
                if (light) {

                    var chkLight = true;
                    var startPosition = {
                        left: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"').position().left + 120,
                        top: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]').position().top + $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]').outerHeight() / 2
                    };
                    if (!link.endStep) {
                        startPosition = {
                            left: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"] .wio_stepAnchor').offset().left - $('#wio_stepsBlocs').offset().left + 24 / 2,
                            top: $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"] .wio_stepAnchor').offset().top - $('#wio_stepsBlocs').offset().top + $('.wio_stepBloc[data-wiostepid="' + link.startStep + '"]').outerHeight() / 2
                        };
                    }

                    if (!link.endStep) {
                        var endPosition = {
                            left: wio_viewportMousePosition.x,
                            top: wio_viewportMousePosition.y
                        };
                    } else {
                        var endStep = getStepByID(link.endStep);
                        if (endStep) {
                            var endPosition = {
                                left: $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').position().left + 120,
                                top: $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').position().top + $('.wio_stepBloc[data-wiostepid="' + link.endStep + '"]').outerHeight() / 2
                            };
                        } else {
                            chkLink = false;
                        }

                    }

                    if (chkLight) {
                        var dx = endPosition.left - startPosition.left;
                        var dy = endPosition.top - startPosition.top;
                        var bezierPos = getBezierXY(wio_lightPosition, startPosition.left, startPosition.top, startPosition.left + dx * 0.33, startPosition.top, startPosition.left + dx * 0.67, endPosition.top, endPosition.left, endPosition.top);
                        light.x = bezierPos.x;
                        light.y = bezierPos.y;

                    }

                }

            }
            wio_lightPosition += 0.005 * delta;
            if (wio_lightPosition > 1) {
                wio_lightPosition = 0;
            }
        }
    }

    function showWinDynamicImg() {
        $('#wio_dynamicImgsTable tbody').html('');
        for (var i = 0; i < wio_currentCustomizer.jsonData.imgConditions.length; i++) {
            var imgCondition = wio_currentCustomizer.jsonData.imgConditions[i];
            addDynamicImage(imgCondition);
        }
        $('#wio_winDynamicImg').modal('show');
    }
    function addDynamicImage(imgData) {
        wio_modifsDone = true;
        var tr = $('<tr data-id="' + imgData.id + '"></tr>');
        tr.append('<td><img src="' + imgData.image + '" /><input type="hidden" name="image"/></td>');
        tr.append('<td><a href="javascript:" data-wioaction="editConditions" class="btn btn-sm btn-secondary"><i class="fas fa-eye me-2"></i>' + wio_data.texts['Visibility conditions'] + '</a></td>');
        tr.append('<td  class="text-end"><a href="javascript:" data-wioaction="removeConditions" class="btn btn-sm btn-danger"><i class="fas fa-trash me-2"></i>' + wio_data.texts['Remove'] + '</a></td>');
        tr.find('img').on('click', function () {
            wio_imgField = $(this).next('input[name="image"]');
            tb_show('', 'media-upload.php?TB_iframe=true');
            return false;
        });
        tr.find('input[name="image"]').val(imgData.image);
        tr.find('input[name="image"]').on('keyup', function () {
            $(this).prev('img').attr('src', $(this).val());
            var img = getDynamicImage($(this).closest('tr').attr('data-id'));
            img.image = $(this).val();
        });
        tr.find('[data-wioaction="editConditions"]').on('click', function () {
            showWinDynamicImgConditions($(this).closest('tr').attr('data-id'));
        });
        tr.find('[data-wioaction="removeConditions"]').on('click', function () {
            var id = $(this).closest('tr').attr('data-id');
            wio_currentCustomizer.jsonData.imgConditions = jQuery.grep(wio_currentCustomizer.jsonData.imgConditions, function (imgCondition) {
                if (imgCondition.id != id) {
                    return imgCondition;
                }
            });
            $(this).closest('tr').remove();
        });
        $('#wio_dynamicImgsTable tbody').append(tr);
    }
    function onTextTypeChanged() {

        if ($('#wio_winEditStepField [name="type"]').val() == 'textfield') {
            if ($('#wio_winEditStepField [name="textType"]').val() == 'text') {
                $('#wio_winEditStepField [name="minLength"]').closest('.row').show();
                $('#wio_winEditStepField [name="maxLength"]').closest('.row').show();
            } else {
                $('#wio_winEditStepField [name="minLength"]').closest('.row').hide();
                $('#wio_winEditStepField [name="maxLength"]').closest('.row').hide();

            }
        }
    }
    function duplicateStep(stepID) {
        var step = getStepByID(stepID);
        if (step) {
            var newStep = JSON.parse(JSON.stringify(step));
            newStep.id = generateID();
            newStep.title += ' (1)';
            newStep.start = false;
            newStep.position[0] += 48;
            newStep.position[1] += 48;

            for (var i = 0; i < newStep.items.length; i++) {
                var item = newStep.items[i];
                item.id = generateFieldID();
            }

            wio_currentCustomizer.jsonData.steps.push(newStep);
            var bloc = generateStepBloc(newStep);
            $('#wio_stepsBlocs').append(bloc);
            updateStepBlocFields(newStep);
            setTimeout(function () {
                $('.tooltip').remove();
                bloc.trigger('click');
            }, 100);

        }
    }
    function duplicateStepField(step, itemID) {
        var item = getStepField(step, itemID);
        if (item) {
            var newItem = JSON.parse(JSON.stringify(item));
            newItem.id = generateFieldID();
            newItem.label += '(1)';
            step.items.push(newItem);
            updateStepBlocFields(step);
            $('.tooltip').remove();
        }
    }
})(jQuery);