(function ($) {
    "use strict";
    var pastSteps = new Array();
    var currentStepID = '';
    var isFirstStep = true;
    var cartFormSelector = 'body.single-product form.cart';
    var currentSelectionSent = false;
    var initialButtonText = '';

    $(document).ready(function () {
        if ($('body.single-product form.cart').length > 0) {
            initCustomizer();
        }
    });
    function initCustomizer() {

        var icon = '';

        if (wio_data.required == 1) {

            $('.single_add_to_cart_button').on('click', function (e) {
                if (!currentSelectionSent) {
                    startCustomization();
                    e.preventDefault();
                    e.stopPropagation();
                    return false;
                }
            });
            initialButtonText = $('button.single_add_to_cart_button').html();
            $('.single_add_to_cart_button').html(wio_data.settings.txtButtonLabel);
        } else {
            var originalBtn = $('.single_add_to_cart_button').first();
            var btn = originalBtn.clone();
            if (btn.is('[type="submit"]')) {
                btn.attr('type', 'button');
                btn.attr('name', 'wio_mainBtn');
                btn.attr('id', 'wio_mainBtn');
                btn.html(wio_data.settings.txtButtonLabel);
                if (wio_data.settings.buttonIcon.length > 3) {
                    btn.prepend('<span class="wio_icon ' + wio_data.settings.buttonIcon + '"></span>');
                }
                btn.on('click', startCustomization);
                originalBtn.after(btn);
                btn.before('<br/>');
            }
        }


        var customizerBloc = $('<div id="wio_customizer" data-wioid="' + wio_data.id + '"></div>');
        $('form.cart').after(customizerBloc);
        if (wio_data.settings.centerContent) {
            customizerBloc.addClass('wio_centerContent');
        }
        if (wio_data.settings.modal) {
            customizerBloc.addClass('wio_modal');
            customizerBloc.addClass('wio_centerContent');
            customizerBloc.before('<div id="wio_modalBackground"></div>');
        }
        var metaBloc = $('<div id="wio_customizerMeta"></div>');
        metaBloc.attr('data-wioid', wio_data.id);
        $('#wio_customizer').after(metaBloc);
        metaBloc.hide();
        var stepsCt = $('<div id="wio_steps"></div>');
        stepsCt.attr('data-wiocustomizerid', wio_data.id);
        $('#wio_customizer').append(stepsCt);

        for (var i = 0; i < wio_data.steps.length; i++) {
            var step = wio_data.steps[i];
            var stepBloc = $('<div class="wio_step" data-wioid="' + step.id + '"></div>');

            if (wio_data.settings.modal) {
                stepBloc.append('<a href="javascript:" class="wio_btnCloseModal"><span class="fas fa-times"></span></a>');
                stepBloc.find('.wio_btnCloseModal').on('click', cancelCustomization);
            }
            stepBloc.append('<div class="wio_stepTitle">' + step.title + '</div>');

            stepBloc.append('<div class="wio_fields"></div>');
            if (!wio_data.settings.modal) {
                stepBloc.find('.wio_fields').addClass('wio_closed');
            }
            stepsCt.append(stepBloc);
            step.items.sort(function (a, b) {
                return a.sort - b.sort
            });

            for (var j = 0; j < step.items.length; j++) {
                var field = step.items[j];
                var fieldBloc = createFieldBloc(field, step);
            }
            if (stepBloc.find('[data-wiotype="selectableImage"]').length > 1) {
                stepBloc.find('[data-wiotype="selectableImage"]').each(function (i) {
                    if (!$(this).is('.wio_imgReady')) {
                        if ($(this).prev('[data-wiotype="selectableImage"]').length == 0) {
                            if ($(this).prev('.wio_row').length > 0) {
                                var ct = $(this).prev('.wio_row');
                                $(this).detach().appendTo(ct);

                            } else {
                                var ct = $('<div class="wio_row"></div>');
                                $(this).before(ct);
                                $(this).detach().appendTo(ct);

                            }
                        }
                        $(this).addClass('wio_imgReady');
                    }
                });
            }
        }
        var iconNextStep = '';
        if (wio_data.settings.nextStepIcon != '') {
            iconNextStep = '<span class="wio_buttonIcon ' + wio_data.settings.nextStepIcon + '"></span>';
        }

        $('#wio_customizer').append('<div id="wio_nextStepCt"></div>');
        $('#wio_nextStepCt').append('<a href="javascript:" id="wio_nextStepBtn" class="wio_button" >' + iconNextStep + wio_data.settings.txtNextStepLabel + '</a>');
        $('#wio_nextStepBtn').on('click', nextStep);
        initWaveFx();
    }
    function cancelCustomization() {
        $('#wio_customizer,#wio_modalBackground').fadeOut();
        if (wio_data.settings.hideForm == 1) {
            $(cartFormSelector).slideDown();
        } else {
            $(cartFormSelector).removeClass('wio_disabled');
        }

    }
    function initWaveFx() {
        jQuery('.wio_button').each(function () {
            var $this = $(this);

            var $ripple = null;
            $this.on('keyup', function () {
                return $this.rippleAnimation();
            }).on('touchstart click focus keydown', function () {
                return null;
            }).on('mousedown', function (event) {
                return $ripple = $this.ripple(event.pageX - $this.offset().left, event.pageY - $this.offset().top);
            }).on('touchend mouseup mouseleave blur dragleave', function (event) {
                return $this.hideRipple($ripple);
            });
        });
    }
    function updateDynamicImage() {
        var image = wio_data.productImage;
        if (image != '') {
            var possibleImages = new Array();
            for (var i = 0; i < wio_data.imgConditions.length; i++) {
                var imgCondition = wio_data.imgConditions[i];
                if (checkConditions(imgCondition)) {
                    possibleImages.push(imgCondition.image);
                }
            }
        }
        if (possibleImages.length > 0) {
            image = possibleImages[0];
        }

        $('.wp-post-image').attr('src', image).attr('data-src', image).removeAttr('srcset').attr('data-large_image', image);
        if ($('.woocommerce-product-gallery__image .zoomImg').length > 0) {
            $('.woocommerce-product-gallery__image .zoomImg').attr('src', image).attr('data-src', image).removeAttr('srcset').attr('data-large_image', image);

        }

        if ($('.wp-post-image').closest('a').length > 0) {
            $('.wp-post-image').closest('a').attr('href', image);
        }
        $('#wio_customizer').data('wioImage', image);
    }

    function createFieldBloc(item, step) {
        var stepBloc = $('.wio_step[data-wioid="' + step.id + '"]');
        var fieldBloc = $('<div class="wio_fieldBloc" data-wiofieldid="' + item.id + '"></div>');
        fieldBloc.attr('data-wiotype', item.type);
        if (stepBloc.length > 0) {
            stepBloc.find('.wio_fields').append(fieldBloc);
            fieldBloc.data('wio_itemID', item.id);
            var requiredTxt = '';
            if (item.required) {
                requiredTxt = ' *';
            }
            if(typeof(item.useTooltip) != 'undefined' && item.useTooltip && item.tooltip.trim().length>0){
                var tooltipBtn = $('<div class="fas fa-info-circle wio_tooltipIcon"></div>');
                tooltipBtn.on('click',function(){
                   if($(this).closest('.wio_fieldBloc').find('.wio_tooltipContent').is('.wio_tooltipShow')){
                       $(this).closest('.wio_fieldBloc').find('.wio_tooltipContent').removeClass('wio_tooltipShow');
                       $(this).closest('.wio_fieldBloc').find('.wio_tooltipContent').slideUp();
                       
                       
                   } else{
                      $(this).closest('.wio_fieldBloc').find('.wio_tooltipContent').addClass('wio_tooltipShow');
                      $(this).closest('.wio_fieldBloc').find('.wio_tooltipContent').slideDown();
                   }
                });
                fieldBloc.append(tooltipBtn);
                
            }

            fieldBloc.append('<label class="wio_fieldLabel" for="wio_field_' + item.id + '">' + item.label + requiredTxt + '</label>');
            if (item.type == 'numberfield') {
                fieldBloc.append('<input type="number" class="wio_field" id="wio_field_' + item.id + '" />');
                fieldBloc.find('.wio_field').val(item.value);
                fieldBloc.find('.wio_field').attr('min', item.min);
                fieldBloc.find('.wio_field').attr('max', item.max);
                fieldBloc.find('.wio_field').on('change focusout keyup', updatePrices);
                if (!item.allowDigits) {
                    fieldBloc.find('.wio_field').on('keydown', function (event) {
                        if (event.key === '.') {
                            event.preventDefault();
                        }
                    });
                }
            } else if (item.type == 'datepicker') {
                fieldBloc.append('<input type="date" class="wio_field" id="wio_field_' + item.id + '" />');

            } else if (item.type == 'selectableImage') {
                fieldBloc.append('<a href="javascript:" class="wio_selectableImage wio_field" id="wio_field_' + item.id + '"><img src="' + item.image + '" alt="' + item.label + '" /></a>');
                fieldBloc.find('img').css({
                    maxHeight: item.maxHeight + 'px'
                });
                if (item.isRadio) {
                    fieldBloc.find('.wio_field').addClass('wio_radioImg');
                    if (fieldBloc.closest('.wio_step').find('.wio_radioImg').length == 1) {
                        fieldBloc.find('.wio_field').addClass('wio_selected');
                    }
                }
                fieldBloc.find('.wio_field').on('click', function () {
                    if ($(this).is('.wio_selected')) {

                        if (!$(this).is('.wio_radioImg')) {
                            $(this).removeClass('wio_selected');

                        }
                    } else {
                        if ($(this).is('.wio_radioImg')) {
                            $(this).closest('.wio_fields').find('.wio_radioImg.wio_selected').removeClass('wio_selected');
                        }
                        $(this).addClass('wio_selected');
                    }
                    updatePrices();
                });
                fieldBloc.find('.wio_field').append('<span class="wio_imgCheckmark fas fa-check-circle"></span>');

            } else if (item.type == 'textfield') {
                fieldBloc.append('<input type="text" class="wio_field" id="wio_field_' + item.id + '" />');
                fieldBloc.find('.wio_field').val(item.valueTxt);
                fieldBloc.find('.wio_field').attr('type', item.textType);
                fieldBloc.find('.wio_field').attr('minlength', item.minLength);
                fieldBloc.find('.wio_field').attr('maxmlength', item.maxLength);
                fieldBloc.find('.wio_field').on('change focusout keyup', updatePrices);

            } else if (item.type == 'color') {
                fieldBloc.append('<input type="color" class="wio_field" id="wio_field_' + item.id + '" />');
                fieldBloc.find('.wio_field').val(item.valueColor);
                var pickr = Pickr.create({
                    el: '#' + 'wio_field_' + item.id,
                    theme: 'nano',
                    container: '#wio_customizer',
                    appClass: 'wio_field',
                    inline: true,
                    useAsButton: true,
                    showAlways: true,
                    swatches: null,
                    components: {
                        preview: true,
                        hue: true,

                        interaction: {
                            input: true
                        }
                    }
                });


                fieldBloc.data('wio_colorpicker', pickr);
                fieldBloc.find('.wio_field').on('change focusout keyup', updatePrices);
            } else if (item.type == 'checkbox') {
                fieldBloc.append('<div class="pretty p-default"></div>');
                if (item.switch) {
                    fieldBloc.find('.pretty').addClass('p-switch');
                }
                fieldBloc.find('.pretty').append('<input type="checkbox" class="wio_field" id="wio_field_' + item.id + '" />');
                fieldBloc.find('.wio_field').on('change', updatePrices);


                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').addClass('state');
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').html('<label>' + item.label + requiredTxt + '</label>');
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').detach().insertAfter(fieldBloc.find('.wio_field'));
            } else if (item.type == 'radio') {
                fieldBloc.append('<div class="pretty p-default  p-round p-thick"></div>');
                fieldBloc.find('.pretty').append('<input type="radio" name="wio_radio_' + step.id + '" class="wio_field" id="wio_field_' + item.id + '" />');
                fieldBloc.find('.wio_field').on('change', updatePrices);
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').addClass('state');
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').html('<label>' + item.label + requiredTxt + '</label>');
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').detach().insertAfter(fieldBloc.find('.wio_field'));
                if (fieldBloc.closest('.wio_step').find('[type="radio"]').length == 1) {
                    fieldBloc.find('.wio_field').prop('checked', true);
                }
            } else if (item.type == 'selectfield') {
                fieldBloc.append('<select class="wio_field" id="wio_field_' + item.id + '"></select>');
                fieldBloc.find('.wio_field').on('change focusout keyup', updatePrices);
                if (item.selectOptions.length > 0) {
                    if (item.selectOptions.indexOf(',') == -1) {
                        fieldBloc.find('.wio_field').append('<option value="' + item.selectOptions + '">' + item.selectOptions + '</option>');
                    } else {
                        var options = item.selectOptions.split(',');
                        for (var k = 0; k < options.length; k++) {
                            fieldBloc.find('.wio_field').append('<option value="' + options[k] + '">' + options[k] + '</option>');
                        }
                    }
                }
            } else if (item.type == 'filefield') {
                 if(typeof(wio_data.settings.txtFilesUpload) == 'undefined' || wio_data.settings.txtFilesUpload == '' ){
                    wio_data.settings.txtFilesUpload = 'Drop files to upload here';
                }
                if(typeof(wio_data.settings.txtFilesUploadSize) == 'undefined' || wio_data.settings.txtFilesUploadSize == '' ){
                    wio_data.settings.txtFilesUploadSize = 'File is too big (max size: {{maxFilesize}}MB)';
                }
                if(typeof(wio_data.settings.txtFilesUploadType) == 'undefined' || wio_data.settings.txtFilesUploadType == '' ){
                    wio_data.settings.txtFilesUploadType = 'Invalid file type';
                }
                if(typeof(wio_data.settings.txtFilesUploadLimit) == 'undefined' || wio_data.settings.txtFilesUploadLimit == '' ){
                    wio_data.settings.txtFilesUploadLimit = 'You can not upload any more files';
                }
                
                fieldBloc.append('<div class="wio_field dropzone" id="wio_field_' + item.id + '"></div>');
                var dropzone = $(this);
                fieldBloc.find('.wio_field').dropzone({
                    url: wio_data.ajaxurl + '?customizerID=' + wio_data.id,
                    paramName: 'file',
                    maxFilesize: item.maxWeight,
                    maxFiles: item.maxSize,
                    addRemoveLinks: true,
                    dictRemoveFile: '',
                    dictCancelUpload: '',
                    acceptedFiles: item.allowedExtensions,
                    dictDefaultMessage: wio_data.settings.txtFilesUpload,
                    dictFileTooBig: wio_data.settings.txtFilesUploadSize,
                    dictInvalidFileType: wio_data.settings.txtFilesUploadType,
                    dictMaxFilesExceeded: wio_data.settings.txtFilesUploadLimit,
                    init: function () {
                        this.on("sending", function (file, xhr, formData) {
                            formData.append("action", 'wio_uploadFiles');
                            formData.append('customizerID', wio_data.id);
                            formData.append('stepID', step.id);
                            formData.append('fieldID', item.id);
                            $('#wio_nextStepBtn').addClass('wio_disabled').fadeOut();

                        });
                        this.on("success", function (file, responseText) {
                            var url = responseText;
                            var thumb = jQuery(file.previewElement);
                            thumb.data('wio_url', url);
                            thumb.data('wio_fileName', file.name);
                            thumb.attr('data-wiourl', url);
                            $('#wio_nextStepBtn').removeClass('wio_disabled').fadeIn();

                        });
                        this.on("complete", function (file, xhr) {
                            if (dropzone.find('.dz-preview:not(.dz-complete)').length == 0 || dropzone.find('.dz-preview').length == 0) {
                                $('#wio_nextStepBtn').removeClass('wio_disabled').fadeIn();
                            }
                        });

                    }
                });
            } else if (item.type == 'textarea') {
                fieldBloc.append('<textarea class="wio_field" id="wio_field_' + item.id + '"></textarea>');
                fieldBloc.find('.wio_field').on('change focusout keyup', updatePrices);
            } else if (item.type == 'button') {
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').hide();
                var icon = '';
                if (item.icon.length > 3) {
                    icon = '<span class="wio_icon ' + item.icon + '"></span>';
                }
                fieldBloc.append('<a href="javascript:" class="wio_field wio_buttonField" id="wio_field_' + item.id + '">' + icon + item.label + '</a>');
                fieldBloc.find('.wio_field').on('click', function () {
                    $(this).toggleClass('wio_selected');
                    updatePrices();
                });
            } else if (item.type == 'richText') {
                fieldBloc.find('.wio_fieldLabel[for="wio_field_' + item.id + '"]').hide();
                fieldBloc.append('<div class="wio_field wioText" id="wio_field_' + item.id + '">' + item.text + '</div>');
            }

        }
        
             if(typeof(item.useTooltip) != 'undefined' && item.useTooltip  && item.tooltip.trim().length>0){
                fieldBloc.append('<div class="wio_tooltipContent">'+item.tooltip+'</div');
            }

        return fieldBloc;
    }
    function startCustomization() {
        pastSteps = new Array();
        if (wio_data.settings.hideForm == 1) {
            $(cartFormSelector).slideUp();
        } else {
            $(cartFormSelector).addClass('wio_disabled');
        }
        $('#wio_customizer .wio_step').hide();
        $('#wio_customizerMeta').slideUp();

        if (wio_data.settings.modal) {
            $('#wio_modalBackground').fadeIn();
            $('#wio_customizer').delay(300).fadeIn();
        } else {
            $('#wio_customizer').slideDown();

        }
        currentStepID = '';
        for (var i = 0; i < wio_data.steps.length; i++) {
            if (wio_data.steps[i].start) {
                currentStepID = wio_data.steps[i].id;
                break;
            }
        }
        if (currentStepID == 0 && wio_data.steps.length > 0) {
            currentStepID = wio_data.steps[0].id;
        }
        updatePrices();
        if (currentStepID != '') {
            showCurrentStep();
        }
    }
    function showCurrentStep() {
        if (isFirstStep) {
            $('#wio_nextStepBtn').delay(500).fadeIn(500);
            $('.wio_step[data-wioid="' + currentStepID + '"]').show();

            $('.wio_step[data-wioid="' + currentStepID + '"] .wio_fields').removeClass('wio_closed');
            isFirstStep = false;
        } else {
            if (wio_data.settings.modal) {
                $('#wio_customizer').css('overflow-y', 'hidden');
            }
            $('.wio_fields').addClass('wio_closed');
            setTimeout(function () {
                $('.wio_step').hide();
                $('.wio_step[data-wioid="' + currentStepID + '"]').show();
                $('.wio_step[data-wioid="' + currentStepID + '"] .wio_fields').delay(300).removeClass('wio_closed');
                if (wio_data.settings.modal) {
                    setTimeout(function () {
                        $('#wio_customizer').css('overflow-y', 'auto');
                    }, 300);
                }


            }, 500);
        }

        setTimeout(function () {
            if ($('.wio_step[data-wioid="' + currentStepID + '"]').find('textarea,select,input').length > 0) {
                $('.wio_step[data-wioid="' + currentStepID + '"]').find('textarea,select,input').first().focus();
            }
            updatePrices();
        }, 500);

    }
    function nextStep() {
        if (validateStep()) {
            var nextLinks = new Array();
            for (var i = 0; i < wio_data.links.length; i++) {
                if (wio_data.links[i].startStep == currentStepID) {
                    nextLinks.push(wio_data.links[i]);
                }
            }
            var possibleNextSteps = new Array();
            for (var i = 0; i < nextLinks.length; i++) {
                var link = nextLinks[i];
                if (checkConditions(link.conditions)) {
                    possibleNextSteps.push(link.endStep);
                }
            }

            if (possibleNextSteps.length > 0) {
                pastSteps.push(currentStepID);
                currentStepID = possibleNextSteps[0];
                showCurrentStep();
            } else {
                finishCustomization();
            }
        }

    }
    function getFieldFromStep(step, fieldID) {
        var field = false;
        for (var i = 0; i < step.items.length; i++) {
            if (step.items[i].id == fieldID) {
                field = step.items[i];
            }
        }
        return field;
    }
    function getStep(stepID) {
        var step = false;
        for (var i = 0; i < wio_data.steps.length; i++) {
            if (wio_data.steps[i].id == stepID) {
                step = wio_data.steps[i];
            }
        }
        return step;
    }
    function getFullSelection() {
        var selection = [];
        var html = '<div id="wio_productSelection" data-wioid="' + wio_data.id + '">';
        html += '<div id="wio_productSelectionTitle">' + wio_data.settings.resumeTitle + '</div>';
        html += '<table>';
        var text = '';
        var total = 0;
        var colspanHead = 1;
        html += '<thead>';
        html += '<tr>';
        html += '<th>' + wio_data.settings.txtOptionName + '</th>';
        html += '<th class="wio_valueTd" colspan="' + colspanHead + '">' + wio_data.settings.txtValue + '</th>';
        if (wio_data.settings.modifyPrice && wio_data.settings.pricesInResume) {
            html += '<th class="wio_priceTd">' + wio_data.settings.txtPrice + '</th>';
        }
        html += '</tr>';
        html += '</thead>';
        html += '<tbody>';
        var pastAndCurrentSteps = JSON.parse(JSON.stringify(pastSteps));
        pastAndCurrentSteps.push(currentStepID);
        for (var i = 0; i < pastAndCurrentSteps.length; i++) {
            var stepID = pastAndCurrentSteps[i];
            var step = getStep(stepID);
            if (step) {
                var hasField = false;
                $('.wio_step[data-wioid="' + stepID + '"]').find('.wio_field').each(function () {
                    var chkField = true;
                    var fieldBloc = $(this).closest('.wio_fieldBloc');
                    var field = $(this);
                    var item = getFieldFromStep(step, fieldBloc.closest('.wio_fieldBloc').attr('data-wiofieldid'));
                    if (item) {
                        if (item.type == 'button' && !field.is('.wio_selected')) {
                            chkField = false;
                        }
                        if (item.type == 'selectableImage' && !field.is('.wio_selected')) {
                            chkField = false;
                        }
                        if ((item.type == 'checkbox' || item.type == 'radio') && !field.is(':checked')) {
                            chkField = false;
                        }
                        if ((item.type == 'filefield') && field.find('.dz-complete').length == 0) {
                            chkField = false;
                        }
                        if (item.type == 'richText') {
                            chkField = false;
                        }
                        if ((item.type == 'textfield' || item.type == 'datepicker' || item.type == 'numberfield') && field.val().length == 0) {
                            chkField = false;
                        }
                        if (chkField) {
                            hasField = true;
                        }
                    }
                });
                if (hasField) {
                    var dbPoints = ':';
                    if (step.title.trim().length > 2 && (step.title.trim().substr(step.title.trim().length - 1) == '?' || step.title.trim().substr(step.title.trim().length - 1) == ':' || step.title.trim().substr(step.title.trim().length - 1) == '.')) {
                        dbPoints = '';
                    }
                    html += '<tr><td colspan="3"><strong>' + step.title + ' ' + dbPoints + ' </strong></td></tr>';

                    text += step.title + dbPoints + "\n";

                    $('.wio_step[data-wioid="' + stepID + '"]').find('.wio_field').each(function () {
                        var fieldBloc = $(this).closest('.wio_fieldBloc');
                        var field = $(this);
                        var item = getFieldFromStep(step, fieldBloc.closest('.wio_fieldBloc').attr('data-wiofieldid'));
                        if (item) {
                            var chkSel = true;
                            if (item.type == 'button' && !field.is('.wio_selected')) {
                                chkSel = false;
                            }
                            if (item.type == 'selectableImage' && !field.is('.wio_selected')) {
                                chkSel = false;
                            }
                            if ((item.type == 'checkbox' || item.type == 'radio') && !field.is(':checked')) {
                                chkSel = false;
                            }
                            if ((item.type == 'filefield') && field.find('.dz-complete').length == 0) {
                                chkSel = false;
                            }
                            if (item.type == 'richText') {
                                chkSel = false;
                            }
                            if ((item.type == 'textfield' || item.type == 'datepicker' || item.type == 'numberfield') && field.val().length == 0) {
                                chkSel = false;
                            }


                            if (chkSel) {

                                html += '<tr>';
                                var fieldData = {
                                    label: item.label,
                                    step: step.title
                                };
                                var valueTxt = '';
                                if (item.type == 'color') {
                                    fieldData.value = fieldBloc.data('wio_colorpicker').getColor().toHEXA().toString();
                                    valueTxt = fieldBloc.data('wio_colorpicker').getColor().toHEXA().toString();
                                }
                                if (item.type == 'textfield' || item.type == 'selectfield' || item.type == 'textarea' || item.type == 'numberfield' || item.type == 'datepicker') {
                                    fieldData.value = field.val();
                                    valueTxt = field.val();
                                }
                                if (item.type == 'filefield') {
                                    var urls = '';
                                    var urlsTxt = '';
                                    field.find('.dz-complete').each(function () {
                                        if ($(this).data('wio_url')) {
                                            urlsTxt += ',' + $(this).data('wio_fileName') + '';
                                            urls += ',<a href="' + $(this).data('wio_url') + '" target="_blank">' + $(this).data('wio_fileName') + '</a>';
                                        }
                                    });
                                    if (urls.length > 0) {
                                        urls = urls.substr(1, urls.length);
                                    }
                                    if (urlsTxt.length > 0) {
                                        urlsTxt = urlsTxt.substr(1, urlsTxt.length);
                                    }
                                    valueTxt = urlsTxt;
                                    fieldData.value = urls;
                                }
                                var priceTxt = '';
                                var colspan = 2;
                                if (wio_data.settings.modifyPrice && wio_data.settings.pricesInResume) {
                                    if (fieldBloc.data('wio_price') && !isNaN(fieldBloc.data('wio_price'))) {
                                        total += parseFloat(fieldBloc.data('wio_price'));
                                        priceTxt = formatPrice(fieldBloc.data('wio_price'));
                                    } else {
                                        priceTxt = formatPrice(0);
                                    }
                                    fieldData.priceTxt = priceTxt;
                                    colspan = 1;
                                }
                                selection.push(fieldData);
                                html += '<td class="wio_labelTd">' + fieldData.label + '</td>';
                                html += '<td class="wio_valueTd" colspan="' + colspan + '">' + valueTxt + '</td>';
                                if (wio_data.settings.modifyPrice && wio_data.settings.pricesInResume) {
                                    html += '<td class="wio_priceTd">' + priceTxt + '</td>';
                                }
                                text += '   - ' + fieldData.label + valueTxt + "\n";
                                html += '</tr>';
                            }
                        }
                    });
                    text += "\n";
                }

            }
        }


        if (wio_data.settings.modifyPrice && wio_data.settings.pricesInResume && wio_data.settings.totalInResume) {
            html += '<tr>';
            var total = parseFloat($('#wio_customizer').data('wio_total')).toFixed(2);
            if (isNaN(total)) {
                total = 0;
            }
            html += '<td colspan="2" class="wio_totalLabelTd">' + wio_data.settings.txtTotal + '</td>';
            html += '<td colspan="2" class="wio_totalTd">' + formatPrice(total) + '</td>';
            html += '</tr>';
        }
        html += '</tbody>';
        html += '</table>';
        html += '</div>';
        return {json: selection, html: html, text: text};
    }


    function finishCustomization() {
        if (wio_data.settings.modal) {
            $('#wio_modalBackground').fadeOut();
            $('#wio_customizer').fadeOut();
        } else {
            $('#wio_customizer').slideUp();
        }
        var selection = getFullSelection();
        var selectionDom = $(selection.html);
        var hasValue = false;
        for (var i = 0; i < selection.json.length; i++) {
            if (typeof (selection.json[i].value) != 'undefined' && selection.json[i].value != '') {
                hasValue = true;
            }
        }
        if (!hasValue) {
            var colspan = parseInt(selectionDom.find('.wio_valueTd').attr('colspan'));
            if (isNaN(colspan)) {
                colspan = 2;
            }
            selectionDom.find('.wio_valueTd').prev('td,th').attr('colspan', colspan + 1);
            selectionDom.find('.wio_valueTd').remove();
            if (selectionDom.find('.wio_totalTd').length > 0) {
                selectionDom.find('.wio_totalTd').attr('colspan', 1);
            }
        }
        $('#wio_customizerMeta').html('').append(selectionDom).delay(500).slideDown();

        var price = 0;
        if (wio_data.settings.modifyPrice && !isNaN(parseFloat($('#wio_customizer').data('wio_total')))) {
            price = parseFloat(wio_data.productPrice) + parseFloat($('#wio_customizer').data('wio_total'));
            price = price.toFixed(2);
        }

        var image = '';
        if (typeof ($('#wio_customizer').data('wioImage')) != 'undefined' && $('#wio_customizer').data('wioImage')) {
            image = $('#wio_customizer').data('wioImage');
        }
        $.ajax({
            url: wio_data.ajaxurl,
            type: 'post',
            data: {
                action: 'wio_finishCustomization',
                customizerID: wio_data.id,
                selection: JSON.stringify(selection.json),
                price: price,
                productID: wio_data.productID,
                image: image,
                preview: wio_data.preview
            },
            success: function () {
                currentSelectionSent = true;
                if (wio_data.settings.hideForm == 1) {
                    $(cartFormSelector).slideDown();
                } else {
                    $(cartFormSelector).removeClass('wio_disabled');
                }
                $('#wio_mainBtn').addClass('wio_done');
                if (wio_data.required == 1) {
                    $('.single_add_to_cart_button').html(initialButtonText);
                }
            }
        });

    }

    function checkConditions(conditions) {
        var rep = true;
        var chkAnd = true;
        var chkOr = false;
        for (var i = 0; i < conditions.conditions.length; i++) {

            var conditionGroup = conditions.conditions[i];
            if (conditionGroup.conditions.length > 0) {
                var chkAndGroup = true;
                var chkOrGroup = false;
                if (conditionGroup.conditions.length > 0 && conditionGroup.operator == 'or') {
                    rep = false;
                }

                for (var j = 0; j < conditionGroup.conditions.length; j++) {
                    if (!checkCondition(conditionGroup.conditions[j])) {
                        chkAndGroup = false;
                    } else {
                        chkOrGroup = true;
                    }
                }
                if (chkAnd && !chkAndGroup) {
                    chkAnd = false;
                }
                if (!chkOr && chkOrGroup) {
                    chkOr = true;
                }

                if (conditionGroup.operator == 'and') {
                    rep = chkAnd
                } else {
                    rep = chkOr;
                }

            }
        }
        return rep;
    }
    function getFieldValue(field) {
        var rep = '';
        if (typeof (field.val) == 'function') {
            rep = field.val();
        }
        return rep;
    }
    function checkCondition(condition) {
        var rep = true;
        var startValue = null;
        var pastAndCurrentSteps = JSON.parse(JSON.stringify(pastSteps));
        pastAndCurrentSteps.push(currentStepID);
        if (condition.startStep != '' && pastAndCurrentSteps.indexOf(condition.startStep) > -1) {

            if ($('#wio_customizer [data-wiofieldid="' + condition.startField + '"]').length > 0) {
                var fieldBloc = $('#wio_customizer [data-wiofieldid="' + condition.startField + '"]');
                var startValue = getFieldValue(fieldBloc.find('.wio_field'));
                var endValue = condition.endValue;
                if (condition.endType == 'field') {
                    var endFieldBloc = $('#wio_customizer [data-wiofieldid="' + condition.endField + '"] ');
                    endValue = getFieldValue(endFieldBloc.find('.wio_field'));
                }
                if (condition.operator == 'isFilled') {
                    if (startValue.length == 0) {
                        rep = false;
                    }
                } else if (condition.operator == 'isntFilled') {
                    if (startValue.length > 0) {
                        rep = false;
                    }

                } else if (condition.operator == 'isEqualTo') {
                    if (startValue != endValue) {
                        rep = false;
                    }
                } else if (condition.operator == 'isDifferentThan') {
                    if (startValue == endValue) {
                        rep = false;
                    }
                } else if (condition.operator == 'isSuperiorTo') {
                    if (parseFloat(startValue) <= parseFloat(endValue)) {
                        rep = false;
                    }
                } else if (condition.operator == 'isInferiorTo') {
                    if (parseFloat(startValue) >= parseFloat(endValue)) {
                        rep = false;
                    }
                } else if (condition.operator == 'isSelected') {
                    if (!fieldBloc.find('.wio_field').is('.wio_selected') && !fieldBloc.find('.wio_field').is(':checked')) {
                        rep = false;
                    }
                } else if (condition.operator == 'isntSelected') {
                    if (fieldBloc.find('.wio_field').is('.wio_selected') || fieldBloc.find('.wio_field').is(':checked')) {
                        rep = false;
                    }
                }

            }

        }
        return rep;
    }
    function formatPrice(price) {
        price = parseFloat(price).toFixed(wio_data.decimalNb);
        price = price.toString().replace('.', wio_data.decimalSeparator);
        
        if (wio_data.thousandSeparator.length > 0) {
            price = addThousandSep(price);
        }

        if (wio_data.currencyPosition == 'right') {
            price = price + wio_data.currency;
        } else if (wio_data.currencyPosition == 'right_space') {
            price = price + ' ' + wio_data.currency;
        } else if (wio_data.currencyPosition == 'left_space') {
            price = wio_data.currency + ' ' + price;
        } else {
            price = wio_data.currency + price;
        }
        return price;
    }

    function updatePrices() {
        if (wio_data.settings.modifyPrice) {
            var total = 0;
            var pastAndCurrentSteps = JSON.parse(JSON.stringify(pastSteps));
            pastAndCurrentSteps.push(currentStepID);
            for (var i = 0; i < pastAndCurrentSteps.length; i++) {
                var stepID = pastAndCurrentSteps[i];
                var step = getStep(stepID);
                var stepBloc = $('.wio_step[data-wioid="' + stepID);
                stepBloc.find('.wio_fieldBloc').each(function () {
                    var itemBloc = $(this);
                    var field = itemBloc.find('.wio_field');
                    var itemID = itemBloc.data('wio_itemID');
                    var item = getFieldFromStep(step, itemID);
                    if (item) {
                        var chkSel = true;
                        if (item.type == 'button' && !field.is('.wio_selected')) {
                            chkSel = false;
                        }
                        if ((item.type == 'checkbox' || item.type == 'radio') && !field.is(':checked')) {
                            chkSel = false;
                        }
                        if (chkSel) {
                            var price = parseFloat(item.price);
                            if (item.useCalculation) {
                                price = executeCalculation(item.priceCalculation);
                            }
                            if (item.type == 'numberfield') {
                                price = parseFloat(price) * parseFloat(field.val());
                            }
                            if (!isNaN(price)) {
                                price = price.toFixed(2);
                                itemBloc.data('wio_price', price);
                                total += parseFloat(price);
                            }
                        }

                    }
                });
            }
            total = total.toFixed(2);
            $('#wio_customizer').data('wio_total', total);
            var productPrice = parseFloat(wio_data.productPrice);

            if (total > 0) {
                productPrice = parseFloat(wio_data.productPrice) + parseFloat(total);
            }
            if (!wio_data.settings.optionsCostNextProductPrice) {
                if ($('.woocommerce-Price-amount bdi').length > 0) {
                    $('.woocommerce-Price-amount bdi').html(formatPrice(productPrice));
                } else if ($('.woocommerce-Price-amount').length > 0) {
                    $('.woocommerce-Price-amount').html(formatPrice(productPrice));
                }
            } else {
                $('#wio_wooproduct_optionsPrice').remove();
                if (total != 0) {
                    var fontSize = 16;
                    if ($('.woocommerce-Price-amount bdi').length > 0) {
                        fontSize = parseInt($('.woocommerce-Price-amount bdi').css('font-size')) - 2;
                        $('.woocommerce-Price-amount bdi').after('<span id="wio_wooproduct_optionsPrice" data-wioid="' + wio_data.id + '">+' + formatPrice(total) + '</span>');
                    } else if ($('.woocommerce-Price-amount').length > 0) {
                        fontSize = parseInt($('.woocommerce-Price-amount bdi').css('font-size')) - 2;
                        $('.woocommerce-Price-amount ').after('<span id="wio_wooproduct_optionsPrice" data-wioid="' + wio_data.id + '">+' + formatPrice(total) + '</span>');
                    }
                    fontSize -= 4;
                    if (fontSize < 15) {
                        fontSize = 15;
                    }
                    $('#wio_wooproduct_optionsPrice').css({
                        fontSize: fontSize
                    });
                }
            }

        }
        if (wio_data.imgConditions.length > 0) {
            updateDynamicImage();
        }
    }

    function executeCalculation(calculation) {
        calculation = calculation.replace(/\\/g, '');
        var price = 0;
        var i = 0;
        var elementsToReplace = new Array();
        while ((i = calculation.indexOf('field-', i + 1)) != -1) {
            var itemID = calculation.substr(i + 6, calculation.indexOf('_', i) - (i + 6));
            var attribute = calculation.substr(calculation.indexOf('_', i) + 1, (calculation.indexOf(']', i) - 1) - (calculation.indexOf('_', i)));
            var value = 0;
            var item = getField(itemID);
            var itemBloc = $('.wio_fieldBloc[data-wiofieldid="' + itemID + '"]');
            var field = itemBloc.find('.wio_field');
            if (item && itemBloc.length > 0) {

                if (attribute == 'isSelected') {
                    if (field.is('.wio_checked') || field.is(':checked')) {
                        value = '1==1';
                    } else {
                        value = '1==0'
                    }
                }
                if (attribute == 'isntSelected') {
                    if (!field.is('.wio_checked') && !field.is(':checked')) {
                        value = '1==1';
                    } else {
                        value = '1==0'
                    }
                }
                if (attribute == 'isFilled') {
                    if (field.val().trim().length > 0) {
                        value = '1==1';
                    } else {
                        value = '1==0'
                    }
                }
                if (attribute == 'isntFilled') {
                    if (field.val().trim().length == 0) {
                        value = '1==1';
                    } else {
                        value = '1==0'
                    }
                }
                if (attribute == 'value') {
                    value = field.val();
                    if(isNaN(value)){
                        value = "'"+value+"'";
                    }
                }
                if (attribute == 'price') {
                    value = itemBloc.data('wio_price');
                }
                elementsToReplace.push({
                    oldValue: calculation.substr(i - 1, (calculation.indexOf(']', i) + 1) - (i - 1)),
                    newValue: value
                });
            }
        }

        $.each(elementsToReplace, function () {
            calculation = calculation.replace(this.oldValue, this.newValue);
        });
        if (calculation.indexOf('[price]') == -1) {
            if (calculation.indexOf('if') < 0) {
                calculation = 'price = ' + calculation;
            } else {
                var charsToStart = calculation.substr(0, calculation.indexOf('if'));
                if (/\S/.test(charsToStart)) {
                    calculation = 'price = ' + calculation;
                }
            }
        } else {
            calculation = calculation.replace(/\[price\]/g, "price");
        }

        var total = 0;
        if (!isNaN($('#wio_customizer').data('wio_total'))) {
            total = parseFloat($('#wio_customizer').data('wio_total'));
        }
        calculation = calculation.replace(/\[total\]/g, total);

        try {
            eval(calculation);
        } catch (e) {
            console.log('wrong calculation : ' + calculation);
        }
        return price;
    }

    function getField(id) {
        var rep = false;
        for (var i = 0; i < wio_data.steps.length; i++) {
            var step = wio_data.steps[i];
            for (var j = 0; j < step.items.length; j++) {
                if (step.items[j].id == id) {
                    rep = step.items[j];
                }
            }
        }
        return rep;
    }

    function validateStep() {
        var rep = true;
        $('.wio_invalid').removeClass('wio_invalid');
        $('.wio_step[data-wioid="' + currentStepID + '"] .wio_fieldBloc').each(function () {
            var isValid = true;
            var item = getField($(this).attr('data-wiofieldid'));
            if (item) {
                if (item.type == 'numberfield') {
                    if (item.required && (isNaN(parseFloat($(this).find('.wio_field').val())) || (parseFloat($(this).find('.wio_field').val()) == 0))) {
                        isValid = false;
                    } else {
                        if (item.max > 0 && $(this).find('.wio_field').val() > item.max)
                        {
                            isValid = false;
                        }
                        if (item.min > 0 && $(this).find('.wio_field').val() < item.min)
                        {
                            isValid = false;
                        }
                    }
                } else if (item.type == 'filefield') {
                     if (item.required && $(this).find('.dz-success.dz-complete').length == 0) {
                        isValid = false;
                    } 
                } else if (item.type == 'textfield' || item.type == 'textarea') {
                    if (item.required && $(this).find('.wio_field').val().trim().length == 0) {
                        isValid = false;
                    } else {
                        if (item.maxLength > 0 && $(this).find('.wio_field').val().trim().length > item.maxLength)
                        {
                            isValid = false;
                        }
                        if (item.minLength > 0 && $(this).find('.wio_field').val().trim().length < item.minLength)
                        {
                            isValid = false;
                        }
                    }

                    if ($(this).find('.wio_field').val().length > 0) {
                        if (item.textType == 'email' && !checkEmail($(this).find('.wio_field').val())) {
                            isValid = false;
                        }
                        if (item.textType == 'url' && !checkUrl($(this).find('.wio_field').val())) {
                            isValid = false;
                        }
                    }

                } else if (item.type == 'button') {
                    if (item.required && !$(this).find('.wio_field').is('.wio_selected')) {
                        isValid = false;
                    }
                } else if (item.type == 'color') {
                    if (item.required && $(this).find('.wio_field').val().find('.wio_field').trim().length != 7) {
                        isValid = false;
                    }
                } else if (item.type == 'checkbox') {
                    if (item.required && !$(this).find('.wio_field').is(':checked')) {
                        isValid = false;
                    }
                } else if (item.type == 'radio') {
                    if (item.required) {
                        isValid = false;
                    }
                }

                if (!isValid) {
                    $(this).addClass('wio_invalid');
                    rep = false;
                }
            }

        });
        return rep;
    }
    function addThousandSep(n) {

        var rx = /(\d+)(\d{3})/;
        return String(n).replace(/^\d+/, function (w) {
            while (rx.test(w)) {
                w = w.replace(rx, '$1' + wio_data.thousandSeparator + '$2');
            }
            return w;
        });

    }
    
    function checkEmail(email) {
        return /^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(email)
    }
    function checkUrl(url) {
        return /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(url);

    }
})(jQuery);