(function ($) {
    "use strict";
    wio_data = wio_data[0];
    var wio_imgField = false;

    $(document).ready(function () {
        $('#wio_dynamicImgsTable [data-wioaction="addImg"]').on('click', addDynamicImage);
        $('#wio_btnDynamicImg').on('click', showWinDynamicImg);

        window.old_tb_remove = window.tb_remove;
        window.tb_remove = function () {
            window.old_tb_remove();
            wio_imgField = null;
        };
        window.original_send_to_editor = window.send_to_editor;
        window.send_to_editor = function (html) {
            if (wio_imgField) {
                var alt = jQuery('img', html).attr('alt');
                var fileurl = jQuery('img', html).attr('src');
                if (jQuery('img', html).length == 0) {
                    fileurl = jQuery(html).attr('src');
                    alt = jQuery(html).attr('alt');
                }
                wio_imgField.val(fileurl);
                wio_imgField.trigger('keyup');
                tb_remove();
            } else {
                window.original_send_to_editor(html);
            }
        };
    });

    function showWinDynamicImg() {
        $('#wio_winDynamicImg').modal('show');
    }
    function addDynamicImage() {
        var newID = generateID();
        var tr = $('<tr data-id="' + newID + '"></tr>');
        tr.append('<td><img src="' + wio_data.placeholderImg + '" /><input type="hidden" name="image"/></td>');
        tr.append('<td><a href="javascript:" class="btn btn-sm btn-secondary"><i class="fas fa-eye me-2"></i>' + wio_data.texts['Visibility conditions'] + '</a></td>');
        tr.append('<td  class="text-end"><a href="javascript:" class="btn btn-sm btn-danger"><i class="fas fa-trash me-2"></i>' + wio_data.texts['Remove'] + '</a></td>');
        tr.find('img').on('click', function () {
            wio_imgField = $(this).next('input[name="image"]');
            tb_show('', 'media-upload.php?TB_iframe=true');
            return false;
        });
         tr.find('input[name="image"]').on('keyup',function(){
            $(this).prev('img').attr('src',$(this).val()); 
         });
        $('#wio_dynamicImgsTable tbody').append(tr);
    }
    function generateID() {

        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }
})(jQuery);