<section id="wio_section_customizerView">
    <div id="wio_stepsAppContainer">
        <div id="wio_stepsBlocs"></div>
    </div>
    <div id="wio_stepsAppCanvas"></div>
    <div id="wio_winEditStepField" class="modal" tabindex="-1">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Edit a field', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="mb-3 row">
                        <label for="wio_editFieldLabel" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Label', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" name="label" class="form-control" id="wio_editFieldLabel" value="<?php echo esc_html__('My label', 'wio'); ?>">
                        </div>
                    </div>
                    <div class="mb-3 row">
                        <label for="wio_editFieldType" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Type', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <select id="wio_editFieldType" name="type" class="form-select">
                                <option value="button"><?php echo esc_html__('Button', 'wio'); ?></option>
                                <option value="checkbox"><?php echo esc_html__('Checkbox', 'wio'); ?></option>
                                <option value="color"><?php echo esc_html__('Color', 'wio'); ?></option>
                                <option value="datepicker"><?php echo esc_html__('Datepicker', 'wio'); ?></option>
                                <option value="filefield"><?php echo esc_html__('File upload', 'wio'); ?></option>
                                <option value="numberfield"><?php echo esc_html__('Number field', 'wio'); ?></option>
                                <option value="radio"><?php echo esc_html__('Radio', 'wio'); ?></option>
                                <option value="selectfield"><?php echo esc_html__('Select menu', 'wio'); ?></option>
                                <option value="selectableImage"><?php echo esc_html__('Selectable image', 'wio'); ?></option>
                                <option value="richText"><?php echo esc_html__('Text', 'wio'); ?></option>
                                <option value="textarea"><?php echo esc_html__('Text area', 'wio'); ?></option>
                                <option value="textfield"><?php echo esc_html__('Text field', 'wio'); ?></option>
                            </select>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="textfield">
                        <label for="wio_editFieldTextType" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Text type', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <select id="wio_editFieldTextType" name="textType" class="form-select">
                                <option value="email"><?php echo esc_html__('Email', 'wio'); ?></option>
                                <option value="text"><?php echo esc_html__('Text', 'wio'); ?></option>
                                <option value="url"><?php echo esc_html__('Url', 'wio'); ?></option>
                            </select>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="selectableImage" >
                        <label for="wio_editFieldImage"  class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Image', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <div class="input-group">
                                <input type="text" name="image" class="form-control form-control-sm" id="wio_editFieldImage">
                                <span class="input-group-text"><a href=javascript:" class="btn btn-sm btn-circle btn-secondary wio_btnImgField">
                                        <i class="fas fa-file-upload"></i>
                                    </a></span>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mb-3 row" >
                        <label for="wio_editFieldUseTooltip" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Add information', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="checkbox" name="useTooltip" class="form-check-input" id="wio_editFieldUseTooltip" >
                        </div>
                    </div>
                    
                    <div class="mb-3 row" >
                        <label for="wio_editFieldTooltip" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Information', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <textarea type="text" name="tooltip" id="wio_editFieldTooltip" ></textarea>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="selectableImage" >
                        <label for="wio_editFieldMaxHeight" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Max height', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="maxHeight" min="32" class="form-control" id="wio_editFieldMaxHeight" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="selectableImage" >
                        <label for="wio_editFieldIsRadio" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Use as radio button', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="checkbox" name="isRadio" class="form-check-input" id="wio_editFieldIsRadio" >
                        </div>
                    </div>

                    <div class="mb-3 row" data-wiotypes="numberfield,textfield,textarea,checkbox,button,filefield" >
                        <label for="wio_editFieldRequired"  class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Required', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="checkbox" name="required" class="form-check-input" id="wio_editFieldRequired" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="checkbox" >
                        <label for="wio_editFieldSwitch"  class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Switchbox', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="checkbox" name="switch" class="form-check-input" id="wio_editFieldSwitch" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="numberfield,checkbox,radio,button,selectableImage" >
                        <label for="wio_editFieldPrice" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Price', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="price" class="form-control" id="wio_editFieldPrice" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="numberfield,checkbox,radio,button,selectableImage">
                        <label for="wio_editFieldUseCalculation" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Price calculation', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input name="useCalculation" class="form-check-input" type="checkbox" value="" id="wio_editFieldUseCalculation"/>
                        </div>
                    </div>
                    <div class="mb-3 row" id="wio_editFieldCalculationBloc">
                        <div class="col-sm-12 text-end">
                            <a href="javascript:" data-wioaction="addCalculationValue" class="btn btn-sm btn-secondary me-2"><i class="fas fa-calculator me-2"></i><?php echo esc_html__('Add a value', 'wio'); ?></a>
                            <a href="javascript:" data-wioaction="addCalculationCondition" class="btn btn-sm btn-secondary me-2"><i class="fas fa-question me-2"></i><?php echo esc_html__('Add a condition', 'wio'); ?></a>
                        </div>
                        <div class="col-sm-12">
                            <textarea name="priceCalculation"></textarea>
                            <div class="alert alert-info mt-2 text-center" id="wio_editFieldNoticeCalcQuantity">
                                <?php echo esc_html__('This price will be automatically multiplied by the filled value', 'wio'); ?>
                            </div>
                        </div>
                    </div>

                    <div class="mb-3 row" data-wiotypes="numberfield">
                        <label for="wio_editFieldDigits" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Allow digits', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input name="allowDigits" class="form-check-input" type="checkbox" value="" id="wio_editFieldDigits"/>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="numberfield">
                        <label for="wio_editFieldMin" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Min value', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="min" class="form-control" id="wio_editFieldMin" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="numberfield">
                        <label for="wio_editFieldMax" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Max value', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="max" class="form-control" id="wio_editFieldMax" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="numberfield">
                        <label for="wio_editFieldValue" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Default value', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="value" class="form-control" id="wio_editFieldValue" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="textfield">
                        <label for="wio_editFieldValueTxt" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Default value', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" name="valueTxt" class="form-control" id="wio_editFieldValueTxt" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="color">
                        <label for="wio_editFieldValueTxt" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Default value', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="color" name="valueColor" class="form-control form-control-color" id="wio_editFieldValueColor" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="richText">
                        <label for="wio_editFieldText" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Text', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <textarea id="wio_editFieldText" name="text" ></textarea>
                        </div>
                    </div>

                    <div class="mb-3 row" data-wiotypes="textfield">
                        <label for="wio_editFieldMinLength" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Min length', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="minLength" class="form-control" id="wio_editFieldMinLength" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="textfield">
                        <label for="wio_editFieldMaxLength" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Max length', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="maxLength" class="form-control" id="wio_editFieldMaxLength" >
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="filefield">
                        <label for="wio_editFieldMaxFiles" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Max files', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="maxFiles" class="form-control" id="wio_editFieldMaxFiles" > 
                            <small><?php echo esc_html__('How many files can be uploaded ?', 'wio'); ?></small>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="filefield">
                        <label for="wio_editFieldMaxWeight" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Max weight', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="number" name="maxWeight" class="form-control" id="wio_editFieldMaxWeight" > 
                            <small><?php echo esc_html__('Fill the maximum allowed file size in Mb', 'wio'); ?></small>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="filefield">
                        <label for="wio_editFieldExtensions" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Allowed extensions', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" name="allowedExtensions" class="form-control" id="wio_editFieldExtensions" placeholder="jpg,png,zip"/>
                            <small><?php echo esc_html__('Fill the allowed extensions names separated by commas', 'wio'); ?></small>
                        </div>
                    </div>
                    <div class="mb-3 row" data-wiotypes="selectfield">
                        <label for="wio_editFieldSelectOptions" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Menu options', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" name="selectOptions" class="form-control" id="wio_editFieldSelectOptions" placeholder="Option A,Option B,Option C"/>
                            <small><?php echo esc_html__('Fill the options names separated by commas', 'wio'); ?></small>
                        </div>
                    </div>

                    <div class="mb-3 row" data-wiotypes="button">
                        <label for="wio_editFieldIcon" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Button icon', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <div class="input-group">
                                <input type="text" name="icon" class="form-control" id="wio_editFieldIcon" />
                                <span class="input-group-text"><a href="https://fontawesome.com/icons?d=gallery&p=2&m=free" target="_blank" class="btn btn-sm btn-circle btn-secondary">
                                        <i class="fas fa-font"></i>
                                    </a></span>
                            </div>
                            <small class=" mb-3">
                                <?php echo esc_html__('Fill a fontawesome icon class, like:', 'wio'); ?> <strong>"fas fa-wrench"</strong>
                            </small>
                        </div>                    
                    </div>

                    <div class="mb-3 row" data-wiotypes="datepicker" >
                        <label for="wio_editFieldPastDate"  class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Allow past dates', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <input type="checkbox" name="pastDate" class="form-check-input" id="wio_editFieldPastDate" >
                        </div>
                    </div>


                </div>
                <div class="modal-footer">
                    <a href="javascript:" class="btn btn-secondary" data-bs-dismiss="modal"><i class="fas fa-times me-2"></i><?php echo esc_html__('Close', 'wio'); ?></a>
                    <a href="javascript:" data-wioaction="saveStepField" type="button" class="btn btn-primary"><i class="fas fa-save me-2"></i><?php echo esc_html__('Save', 'wio'); ?></a>
                </div>
            </div>
        </div>
    </div>

    <div id="wio_winSettings" class="modal " tabindex="-1">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Settings', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body pt-0">
                    <ul class="nav justify-content-center border-bottom mb-3">
                        <li class="nav-item mb-0">
                            <a class="nav-link active" data-wiotab="options" aria-current="page" href="javascript:">
                                <i class="fas fa-cogs"></i>
                                <?php echo esc_html__('Options', 'wio'); ?>
                            </a>
                        </li>
                        <li class="nav-item mb-0">
                            <a class="nav-link"  data-wiotab="texts" href="javascript:">
                                <i class="fas fa-font"></i>
                                <?php echo esc_html__('Texts', 'wio'); ?>
                            </a>
                        </li>
                        <li class="nav-item mb-0">
                            <a class="nav-link"  data-wiotab="design" href="javascript:">
                                <i class="fas fa-palette"></i>
                                <?php echo esc_html__('Design', 'wio'); ?>
                            </a>
                        </li>
                        <li class="nav-item mb-0">
                            <a class="nav-link"  data-wiotab="custom" href="javascript:">
                                <i class="fas fa-screwdriver"></i>
                                <?php echo esc_html__('Custom code', 'wio'); ?>
                            </a>
                        </li>
                    </ul>

                    <div>
                        <div data-wiotab="options">


                            <div class="mb-3 row">
                                <label for="wio_editFieldTitle" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Title', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="text" name="title" class="form-control form-control-sm" id="wio_editFieldTitle" >
                                </div>
                            </div>


                            <?php
                            if (function_exists('icl_register_string')) {
                                ?>
                                <div class="mb-3 row">
                                    <label for="wio_settings_useWPML" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Use WPML translations', 'wio'); ?></label>
                                    <div class="col-sm-8">
                                        <input type="checkbox" name="useWPML" class="form-check-input" id="wio_settings_useWPML" />
                                        <small class="text-start mb-3 ms-2">
                                            <?php echo esc_html__('If this option is enabled, the plugin will show the WPML translations in the customizer texts', 'wio'); ?>
                                        </small>  
                                    </div>                 
                                </div>
                                <?php
                            }
                            ?>  <div class="mb-3 row">
                                <label for="wio_settings_hideForm" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Hide product form during customization', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="checkbox" name="hideForm" class="form-check-input" id="wio_settings_hideForm" />
                                    <small class="text-start mb-3 ms-2">
                                        <?php echo esc_html__('If this option is enabled, the selection form of the woo product page will be hidden during the customization. Otherwise it will simply be disabled.', 'wio'); ?>
                                    </small>  
                                </div>                 
                            </div>


                            <div class="mb-3 row">
                                <label for="wio_settings_modifyPrice" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Modify the product price', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="checkbox" name="modifyPrice" class="form-check-input" id="wio_settings_modifyPrice" />

                                    <small class="text-start mb-3 ms-2">
                                        <?php echo esc_html__('This option must be enabled to activate price options', 'wio'); ?>
                                    </small>  
                                </div>                 
                            </div>

                            <div class="mb-3 row">
                                <label for="wio_settings_optionsCostNextProductPrice" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Show options price next to the product price', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="checkbox" name="optionsCostNextProductPrice" class="form-check-input" id="wio_settings_optionsCostNextProductPrice" />

                                    <small class="text-start mb-3 ms-2">
                                        <?php echo esc_html__('If this option is enabled, the plugin will show the options cost next to the main price on the product page. Otherwise it will modify directly the main profuct price.', 'wio'); ?>
                                    </small>   
                                </div>                 
                            </div>

                            <div class="mb-3 row">
                                <label for="wio_settings_pricesInResume" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Show prices in the resume', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="checkbox" name="pricesInResume" class="form-check-input" id="wio_settings_pricesInResume" >
                                </div>                    
                            </div>

                            <div class="mb-3 row">
                                <label for="wio_settings_totalInResume" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Show total price in the resume', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <input type="checkbox" name="totalInResume" class="form-check-input" id="wio_settings_totalInResume" >
                                </div>                    
                            </div>


                        </div>

                        <div data-wiotab="texts">
                            <div class="mb-3 row">

                                <label for="wio_settings_btnLabel" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Main button label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtButtonLabel" class="form-control form-control-sm" id="wio_settings_btnLabel" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">

                                <label for="wio_settings_resumeTitle" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Options resume title', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="resumeTitle" class="form-control form-control-sm" id="wio_settings_resumeTitle" >
                                </div>                    
                            </div>

                            <div class="mb-3 row">
                                <label for="wio_settings_nextStepLabel" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Next step button label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtNextStepLabel" class="form-control form-control-sm" id="wio_settings_nextStepLabel" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtTotal" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Total label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtTotal" class="form-control form-control-sm" id="wio_settings_txtTotal" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtOptionName" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Option name label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtOptionName" class="form-control form-control-sm" id="wio_settings_txtOptionName" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtValue" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Quantity label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtValue" class="form-control form-control-sm" id="wio_settings_txtValue" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtPrice" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Price', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtPrice" class="form-control form-control-sm" id="wio_settings_txtPrice" >
                                </div>                    
                            </div>
                            
                             <div class="mb-3 row">
                                <label for="wio_settings_txtFilesUpload" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('File upload drop label', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtFilesUpload" class="form-control form-control-sm" id="txtFilesUpload" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtFilesUploadSize" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('File upload size error', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtFilesUploadSize" class="form-control form-control-sm" id="txtFilesUploadSize" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtFilesUploadType" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('File upload type error', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtFilesUploadType" class="form-control form-control-sm" id="txtFilesUploadType" >
                                </div>                    
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_txtFilesUploadLimit" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('File upload limit error', 'wio'); ?></label>
                                <div class="col-sm-9">
                                    <input type="text" name="txtFilesUploadLimit" class="form-control form-control-sm" id="txtFilesUploadLimit" >
                                </div>                    
                            </div>
                            
                        </div>

                        <div data-wiotab="design">

                            <div class="row">

                                <div class="mb-3 col-12">
                                    <div class="row">

                                        <label for="wio_settings_googleFont" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Google font', 'wio'); ?></label>
                                        <div class="col-sm-9">
                                            <div class="input-group">
                                                <input type="text" name="googleFont" class="form-control form-control-sm" id="wio_settings_btnIcon" />
                                                <span class="input-group-text"><a href="https://fonts.google.com/" target="_blank" class="btn btn-sm btn-circle btn-secondary">
                                                        <i class="fas fa-font"></i>
                                                    </a></span>
                                            </div>
                                            <small class=" mb-3">
                                                <?php echo esc_html__('Fill a Google font name or leave empty', 'wio'); ?>
                                            </small>
                                        </div>     
                                    </div>
                                </div>
                                <div class="mb-3 col-12">

                                    <div class=" row">
                                        <label for="wio_settings_buttonIcon" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Main button icon', 'wio'); ?></label>
                                        <div class="col-sm-9">
                                            <div class="input-group">
                                                <input type="text" name="buttonIcon" class="form-control form-control-sm" id="wio_settings_buttonIcon" />
                                                <span class="input-group-text"><a href="https://fontawesome.com/icons?d=gallery&p=2&m=free" target="_blank" class="btn btn-sm btn-circle btn-secondary">
                                                        <i class="fas fa-font"></i>
                                                    </a></span>
                                            </div>
                                            <small class=" mb-3">
                                                <?php echo esc_html__('Fill a fontawesome icon class, like:', 'wio'); ?> <strong>"fas fa-wrench"</strong>
                                            </small>
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-12">

                                    <div class=" row">
                                        <label for="wio_settings_nextStepIcon" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Next step icon', 'wio'); ?></label>
                                        <div class="col-sm-9">
                                            <div class="input-group">
                                                <input type="text" name="nextStepIcon" class="form-control form-control-sm" id="wio_settings_nextStepIcon" />
                                                <span class="input-group-text"><a href="https://fontawesome.com/icons?d=gallery&p=2&m=free" target="_blank" class="btn btn-sm btn-circle btn-secondary">
                                                        <i class="fas fa-font"></i>
                                                    </a></span>
                                            </div>
                                            <small class=" mb-3">
                                                <?php echo esc_html__('Fill a fontawesome icon class, like:', 'wio'); ?> <strong>"fas fa-wrench"</strong>
                                            </small>
                                        </div>                    
                                    </div>
                                </div>
                            </div>


                            <div class="row">

                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_backgroundColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="backgroundColor" class="form-control form-control-sm form-control-color" id="wio_settings_backgroundColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_textColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="textColor" class="form-control form-control-sm form-control-color" id="wio_settings_textColor" >
                                        </div>                    
                                    </div>
                                </div>


                            </div>

                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_nextStepColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Next step background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="nextStepColor" class="form-control form-control-sm form-control-color" id="wio_settings_nextStepColor" >
                                        </div>                    
                                    </div>
                                </div>

                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_nextStepTxtColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Next step text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="nextStepTxtColor" class="form-control form-control-sm form-control-color" id="wio_settings_nextStepTxtColor" >
                                        </div>                    
                                    </div>
                                </div>

                            </div>

                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_otherBtnsColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Other buttons background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="otherBtnsColor" class="form-control form-control-sm form-control-color" id="wio_settings_otherBtnsColor" >
                                        </div>                    
                                    </div>
                                </div>

                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_otherBtnsTxtColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Next step text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="otherBtnsTxtColor" class="form-control form-control-sm form-control-color" id="wio_settings_otherBtnsTxtColor" >
                                        </div>                    
                                    </div>
                                </div>

                            </div>
                            <div class="row">

                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_tableHeaderColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Table header background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="tableHeaderColor" class="form-control form-control-sm form-control-color" id="wio_settings_tableHeaderColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_tableHeaderTxtColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Table header text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="tableHeaderTxtColor" class="form-control form-control-sm form-control-color" id="wio_settings_tableHeaderTxtColor" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_tableBgColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Table background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="tableBgColor" class="form-control form-control-sm form-control-color" id="wio_settings_tableBgColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_tableTxtColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Table text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="tableTxtColor" class="form-control form-control-sm form-control-color" id="wio_settings_tableTxtColor" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_checkboxColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Checkbox main color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="checkboxColor" class="form-control form-control-sm form-control-color" id="wio_settings_checkboxColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_tableBorderColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Table border color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="tableBorderColor" class="form-control form-control-sm form-control-color" id="wio_settings_tableBorderColor" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_fieldsColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Fields background color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="fieldsColor" class="form-control form-control-sm form-control-color" id="wio_settings_fieldsColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_fieldsTxtColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Fields text color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="fieldsTxtColor" class="form-control form-control-sm form-control-color" id="wio_settings_fieldsTxtColor" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_fieldsBorderColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Fields border color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="fieldsBorderColor" class="form-control form-control-sm form-control-color" id="wio_settings_fieldsBorderColor" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_fieldBorder" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Fields border width', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="fieldsBorderWidth" class="form-control form-control-sm" id="wio_settings_fieldBorder" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_fontSize" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Font size', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="fontSize" class="form-control form-control-sm" id="wio_settings_fontSize" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_resumeFontSize" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Resume font size', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="resumeFontSize" class="form-control form-control-sm" id="wio_settings_resumeFontSize" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_titleFontSize" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Title font size', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="titleFontSize" class="form-control form-control-sm" id="wio_settings_titleFontSize" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_panelPadding" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Panel padding', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="panelPadding" class="form-control form-control-sm" id="wio_settings_panelPadding" >
                                        </div>    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_btnsRadius" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Buttons radius', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="number" name="btnsRadius" class="form-control form-control-sm" id="wio_settings_btnsRadius" >
                                        </div>                    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_errorColor" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Error color', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="color" name="errorColor" class="form-control form-control-sm form-control-color" id="wio_settings_errorColor" >
                                        </div>                    
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_modal" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Show as modal', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="checkbox" name="modal" class="form-check-input" id="wio_settings_popup" >
                                        </div>    
                                    </div>
                                </div>
                                <div class="mb-3 col-6">
                                    <div class="row">
                                        <label for="wio_settings_centerContent" class="col-sm-8 col-form-label-sm"><?php echo esc_html__('Center content', 'wio'); ?></label>
                                        <div class="col-sm-4">
                                            <input type="checkbox" name="centerContent" class="form-check-input" id="wio_settings_centerContent" >
                                        </div>    
                                    </div>
                                </div>
                            </div>



                        </div>
                        
                        
                        <div data-wiotab="custom">

                            <div class="mb-3 row">
                                <label for="wio_settings_customCSS" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Custom CSS', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <textarea  name="customCSS" class="form-control form-control-sm" id="wio_settings_customCSS" ></textarea>
                                </div>
                            </div>
                            <div class="mb-3 row">
                                <label for="wio_settings_customJS" class="col-sm-4 col-form-label-sm"><?php echo esc_html__('Custom JS', 'wio'); ?></label>
                                <div class="col-sm-8">
                                    <textarea name="customJS" class="form-control form-control-sm" id="wio_settings_customJS"></textarea>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>

                <div class="modal-footer">
                    <a href="javascript:" class="btn btn-secondary" data-bs-dismiss="modal"><?php echo esc_html__('Close', 'wio'); ?></a>
                    <a href="javascript:" data-wioaction="saveSettings" type="button" class="btn btn-primary"><i class="fas fa-save me-2"></i><?php echo esc_html__('Save', 'wio'); ?></a>

                </div>
            </div>
        </div>

    </div>



    <div id="wio_winEditLink" class="modal " tabindex="-1">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Edit a link', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div id="wio_conditionsPanel" class="px-2">

                        <div id="wio_conditionLinkInfo" class="text-center fs-5 mb-3 pb-3">
                            From <strong id="wio_conditionLink_startStep">Step A</strong> to <strong id="wio_conditionLink_endStep">Step B</strong>
                        </div>
                        <div class="text-center">
                            <a href="javascript:" data-wioaction="addOptionConditionGroup" class="btn btn-sm btn-primary mb-2">
                                <i class="fas fa-plus"></i>
                                <?php echo esc_html__('Add a conditions group', 'wab'); ?> 
                            </a>
                        </div>
                        <div id="wio_linkConditionsList" class="p-2">

                        </div>
                    </div>
                </div>
                <div class="modal-footer text-center">
                    <a href="javascript:" data-wioaction="insertConditions" class="btn btn-sm btn-primary mb-2">
                        <i class="fas fa-plus"></i>
                        <?php echo esc_html__('Insert', 'wab'); ?> 
                    </a>
                    <a href="javascript:" data-wioaction="deleteLink" class="btn btn-sm btn-danger mb-2">
                        <i class="fas fa-trash"></i>
                        <?php echo esc_html__('Delete this link', 'wab'); ?> 
                    </a>
                </div>
            </div>
        </div>
    </div>

    <div id="wio_winSelectValue" class="modal " tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Select a value', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="mb-3 row">
                        <label for="wio_selectValueItem" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Field', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <select name="itemID" class="form-control" id="wio_selectValueItem">                                
                            </select>
                        </div>
                    </div>
                    <div class="mb-3 row wio_hidden">
                        <label for="wio_selectValueAttribute" class="col-sm-3 col-form-label-sm"><?php echo esc_html__('Attribute', 'wio'); ?></label>
                        <div class="col-sm-9">
                            <select name="attribute" class="form-control" id="wio_selectValueAttribute">                                
                            </select>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <a href="javascript:" class="btn btn-secondary" data-bs-dismiss="modal"><?php echo esc_html__('Close', 'wio'); ?></a>
                    <a href="javascript:" data-wioaction="insertValue" type="button" class="btn btn-primary"><i class="fas fa-check me-2"></i><?php echo esc_html__('Insert this value', 'wio'); ?></a>

                </div>
            </div>
        </div>
    </div>

    <div id="wio_winPreview" class="modal " tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Preview', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label class="mb-3"><?php echo esc_html__('Select a product', 'wio'); ?></label>
                        <input name="wio_previewSelectProductID" class="form-control" type="hidden" />
                        <input  id="wio_previewSelectProduct" class="form-control " type="text" />
                        <small><?php echo esc_html__('Start to write the product title', 'wio'); ?></small>
                    </div>
                </div>
                <div class="modal-footer">
                    <a href="javascript:" class="btn btn-secondary" data-bs-dismiss="modal"><i class="fas fa-times me-2"></i><?php echo esc_html__('Close', 'wio'); ?></a>
                    <a href="javascript:" class="btn btn-primary"  data-wioaction="startPreview"><i class="fas fa-save me-2"></i><?php echo esc_html__('Preview', 'wio'); ?></a>                    
                </div>
            </div>
        </div>
    </div>
    <div id="wio_winDynamicImg" class="modal " tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Dynamic image', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-info  text-center"><?php echo esc_html__('The main image of the product will be dynamically replaced by the one that has its visibility conditions filled', 'wio'); ?></div>

                    <table id="wio_dynamicImgsTable" class="table table-striped">
                        <thead>
                        <th><?php echo esc_html__('Image', 'wio'); ?></th>
                        <th><?php echo esc_html__('Conditions', 'wio'); ?></th>
                        <th class="text-end"><a href="javascript:" class="btn btn-sm btn-primary" data-wioaction="addImg"><i class="fas fa-plus me-2"></i><?php echo esc_html__('Add an image', 'wio'); ?></a></th>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    <div id="wio_toastSaveBeforeLeave" class="toast position-fixed  bg-light" role="alert" aria-live="assertive" aria-atomic="true">
        <div class="toast-body">
            <?php echo esc_html__('Do you want to save this customizer before leaving ?', 'wio'); ?>
            <div class="mt-2 pt-2 border-top text-end">
                <a href="javascript:" class="btn btn-secondary btn-sm" data-bs-dismiss="toast"><i class="fas fa-times me-2"></i><?php echo esc_html__('Cancel', 'wio'); ?></a>
                <a href="javascript:" class="btn btn-danger btn-sm" data-wioaction="leave"><i class="fas fa-door-open me-2"></i><?php echo esc_html__('No', 'wio'); ?></a>
                <a href="javascript:" class="btn btn-primary btn-sm" data-wioaction="saveAndLeave"><i class="fas fa-save me-2"></i><?php echo esc_html__('Yes', 'wio'); ?></a>
            </div>
        </div>
    </div>
    <div id="wio_toastSaved" class="toast position-fixed  bg-light" role="alert" aria-live="assertive" aria-atomic="true">
        <div class="toast-body">
            <i class="fas fa-save me-2"></i>
            <?php echo esc_html__('The customizer has been correctly saved', 'wio'); ?>
        </div>
    </div>

    <nav id="wio_footerCustomizerView" class="navbar fixed-bottom navbar-expand-sm navbar-dark bg-dark p-2">

        <a href="javascript:" data-wioaction="openSettings" type="button" class="btn btn-secondary me-2"><i class="fas fa-cogs me-2"></i><?php echo esc_html__('Settings', 'wio'); ?></a>
        <a href="javascript:" data-wioaction="editDynamicImg" type="button" class="btn btn-secondary me-2"><i class="far fa-images me-2"></i><?php echo esc_html__('Dynamic image', 'wio'); ?></a>

        <div class="float-end">
            <a href="javascript:" data-wioaction="addStep" type="button" class="btn btn-secondary me-2"><i class="fas fa-plus me-2"></i><?php echo esc_html__('Add a step', 'wio'); ?></a>
            <a href="javascript:" data-wioaction="savePreview" type="button" class="btn btn-secondary me-2"><i class="far fa-eye me-2"></i><?php echo esc_html__('Save & preview', 'wio'); ?></a>

            <a href="javascript:" data-wioaction="saveCustomizer" type="button" class="btn btn-primary"><i class="fas fa-save me-2"></i><?php echo esc_html__('Save', 'wio'); ?></a>                

        </div>
    </nav>

</section>