<section id="wio_section_customizersList" class="p-4">
    <div class="container">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
            <h3><?php echo esc_html__('Customizers list', 'wio'); ?></h3>
            <div class="btn-toolbar mb-2 mb-md-0">
                <a href="javascript:" data-wioaction="importData" type="button" class="btn btn-outline-secondary me-2"><i class="fas fa-cloud-download-alt me-2"></i><?php echo esc_html__('Import data', 'wio'); ?></a>
                <a href="javascript:" data-wioaction="exportData" type="button" class="btn btn-outline-secondary me-2"><i class="fas fa-cloud-upload-alt me-2"></i><?php echo esc_html__('Export data', 'wio'); ?></a>
                <a href="javascript:" data-wioaction="createCustomizer" class="btn btn-primary">
                    <i class="fas fa-plus"></i>
                    <?php echo esc_html__('Create a customizer', 'wio'); ?>
                </a>
            </div>
        </div>

        <div class="table-responsive">
            <table class="table table-striped mb-0">
                <thead class="bg-primary">
                    <tr>
                        <th><?php echo esc_html__('Title', 'wio'); ?></th>
                        <th class="wio_tdAction"><?php echo esc_html__('Actions', 'wio'); ?></th>
                    </tr>
                </thead>
                <tbody>           
                </tbody>
            </table>
        </div>
    </div>

    <div id="wio_toastRemoveCustomizer" class="toast position-absolute top-0 end-0  bg-light" role="alert" aria-live="assertive" aria-atomic="true">
        <div class="toast-body">
            <?php echo esc_html__('Do you want to delete this customizer ?', 'wio'); ?>
            <div class="mt-2 pt-2 border-top text-end">
                <a href="javascript:" class="btn btn-secondary btn-sm" data-bs-dismiss="toast"><i class="fas fa-times me-2"></i><?php echo esc_html__('Cancel', 'wio'); ?></a>
                <a href="javascript:" class="btn btn-danger btn-sm" data-wioaction="confirmRemoveCustomizer"><i class="fas fa-trash me-2"></i><?php echo esc_html__('Delete it', 'wio'); ?></a>
                
            </div>
        </div>
    </div>

    <div id="wio_winImportData" class="modal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo esc_html__('Import data', 'wio'); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body text-center">
                    <p>
                        <?php echo esc_html__('Upload your wio_export.zip file to import its data', 'wio'); ?>
                    </p>
                    <form id="wio_winImportForm" class="mb-3" method="post" enctype="multipart/form-data">
                        <div class="form-group">
                            <input type="hidden" name="action" value="wio_importData"/>                            
                            <input name="importFile" type="file" class="" />
                        </div>
                    </form>
                    <div class="alert alert-danger">
                        <?php echo esc_html__('Importing this data will delete all the current customizers data', 'wio'); ?>
                    </div>
                </div>
                <div class="modal-footer">
                    <a href="javascript:" class="btn btn-secondary" data-bs-dismiss="modal"><i class="fas fa-times me-2"></i><?php echo esc_html__('Close', 'wio'); ?></a>
                    <a href="javascript:" data-wioaction="confirmImportData" type="button" class="btn btn-primary"><i class="fas fa-cloud-download-alt me-2"></i><?php echo esc_html__('Import', 'wio'); ?></a>

                </div>
            </div>
        </div>
    </div>
</section>